#ifndef _CPLRAW_FAILABLE_HXX_
#define _CPLRAW_FAILABLE_HXX_

#ifndef _MM_NO_IOSTREAM
#include <iostream>
#endif 
#include <string.h>

  /*
   * 
   */
  class Failable {
    enum StatE {
      E_OK,
      E_FAIL = 001,
      E_BAD =  002 ,
      E_NEXT = 004
    }  _eStat;

    int _iErr;
    const char *_szErr;		/* must be static	*/

   protected:
    Failable& Failable::setStat(StatE eStat, const char *sz, int i);
    Failable& Failable::setStat(const Failable &fa);


    #ifndef _MM_NO_IOSTREAM
      friend std::ostream &operator<<(std::ostream &, const Failable &);
    #endif
   public:
    bool isGood() const { return _eStat == 0; }				/* fine 		*/
    int print(char *sz, unsigned size) const;
    int iErr() { return _iErr; }
    const char *szErr() { return _szErr; }

    /* 
     * last op failed, but object is uncorrupted
     */
    bool isFail() const { return (_eStat & (E_FAIL|E_BAD))!=0; }

    /* 
     * last op failed, object is corrupted
     */
    bool isBad() const { return (_eStat & E_BAD) != 0; }

    bool operator!() const { return isFail(); }
    operator const void * () const { return isFail() ? 0 : this ; }

    /* to be implemented */
    Failable &setFailed(const char*sz, int i, const Failable *) { return setStat(E_FAIL, sz, i); }
    Failable &setBad(const char*sz, int i, const Failable *) { return setStat(E_BAD, sz, i); }

    Failable &setFailed(const char*sz, int i=0) { return setStat(E_FAIL, sz, i); }
    Failable &setBad(const char*sz, int i=0) { return setStat(E_BAD, sz, i); }

    Failable();
    ~Failable(); 
  };

#endif
