
/*
 */
#ifndef _GPIB_GUT_HXX_
#define _GPIB_GUT_HXX_

#include "gpib/gumi_user.hxx"
#include "gpibc/gumi_msgs.hxx"
#include <iostream>

namespace INdepGpib100 {
  namespace Umi=INdepUmi100;
  /*
   * GPIB user base class (Test)
   *
   * provides test access
   */
  class GpibTest {
    Umi::Umi *_pum;
    ErrE _eErr;				/* result of last call	*/
    Umi::Umi *pum() const { return _pum; }

   protected:
    /*
     * result managers
     */
    int setFailed( Umi::Umi *, int i ) {  return i; }	/* UMI failed		*/
    GpibTest &setFailed( Umi::Umi * ) {  return *this; }	/* UMI failed		*/

   public:
    friend std::ostream &operator <<( std::ostream &os, const GpibTest &lr );
    bool operator!() const { return pum()->isFail(); }


    /* 
     * Manufacturing Test Provisions 
     *
     * These functions allow to access the GPIB controller hardware
     * registers directly. Do not use except for manufacturing tests.
     */
    int peek(int i);			/* read hardware register byte  */
    GpibTest &poke(int i, int x);	/* write hardware register byte */
    GpibTest &ping(GpibInfo*);
    

    GpibTest(Failable *pfa,  const Umi::Factory *puf);
    ~GpibTest() ;
  };
}

#endif
