#ifndef _GPIB_GPIB_CARDS_H_
#define _GPIB_GPIB_CARDS_H_ 1

#include "arch.h"


#define SZ_CARD_ID 32
#define MAX_PCI_REGION 2
#define MAX_REGION MAX_PCI_REGION 

#ifdef __cplusplus 
extern "C" {
#endif

  enum GcType {
    CT_GPIB_PCI_XL,
    CT_GPIB_PCI,
    CT_GPIB_PC104,
    CT_GPIB_PCMCIA,
    CT_GPIB_PC,
    CNT_CARDTYPES
  };

  /*
   * Card types
   */
  struct RegionDesc {
    int _iBar;			/* PCI bar offset  		*/
    int _f;
    int _l;			/* region length in bytes	*/
  };

  #define RG_AMCC5920_CONF 001	/* AMCC local config region	*/
  #define RG_IOBASE 002		/* GPIB register region		*/
  #define RG_IOMEM 004		/* GPIB memory region		*/
  #define RG_ISMEM(x) (((x) & RG_IOMEM)!=0)

  struct CardType {
    int _eCard;			/* enumerates all known cards	*/
    const char *_szName;
    const char *_szArch; 	/* controller chip architecture */
    enum GcArchE _eArch;	/* architecture enumerated	*/
    
    int _eBus;			/* bus type	*/
    int _isaLen;		/* ISA only: size of IO region */

    /* pci regions */
    struct RegionDesc _mprd[MAX_PCI_REGION];
  };
  extern const struct CardType mpct[CNT_CARDTYPES+1];
  extern const struct RegionDesc *getRegionBySize(const struct CardType *, int len);

#ifdef __cplusplus 
}
#endif

#endif 

