
#ifndef _GPIB_GTI_HXX_
#define _GPIB_GTI_HXX_

#include "gumi_msgs.hxx"
#include "umic/umi_driver.hxx"
#include "gpibc/regs.hxx"
#include "gca.hxx"
#include "cplRaw/sm.hxx"
#include "igcregs.h"
#include "cards.h"
#ifndef _MM_NO_IOSTREAM
 #include <iostream>
#endif

namespace INdepGpib100 {
  namespace Umi=INdepUmi100;

  /*
   * NEC 7210 based interface - Controller and Device 
   */
  class GifTest:public Umi::UmiDriver, private SmM {

   private: 
    enum { S_IDLE, S_INIT };

    /* message handlers */
    int msgNop(int iCtx, const Umi::UmiMsgDown *pmd );
    int msgPeek(int iCtx, Umi::Pmd pmd);
    int msgPoke(int iCtx, Umi::Pmd pmd);


    /* variables */
    int _cIntr;				/* interrupt counter		*/
    GifCard *pca() { return static_cast<GifCard*>(Umi::UmiDriver::pca()); }
    int putBackDone( int iCtx, const Umi::UmiMsgDown *pmd , ErrE e, int iErr =0 );

    const Gpib_gti0_Proto _pt;		/* protocol instance		*/
   public:

    /* debug print */
 #ifndef _MM_NO_IOSTREAM
    friend std::ostream &operator<< ( std::ostream &os, const GifTest &);
 #endif
    char *print( char *, int );
    const Umi::UmiProto *pup(int iChan);		/* proto desc for channel */

    /* 
     * message put -- Note: timer() must has been called 
     * once before using putDown() the first time
     */ 
    int putDown(int iCtx, Umi::Pmd pmd, int iChan);

    int open(int iChan);
    void close(int iChan);

    /* interupt handler */
    int interrupt(int iCtx);

    /* timer handler */
    int timer(int iCtx, const Umi::Time &ti);

    GifTest(GifCard *pca);
    virtual ~GifTest();
  };


}
#endif

