
#ifndef _UMI_UMI_K_HXX_
#define _UMI_UMI_K_HXX_ 1

/*
 * umi_k.hxx - UMI Kernel Interface Service Provider
 *
 * %LEGAL%
 */

#include "umi_user.hxx"
#if (defined(MMSYS_linux))
#else
  #include <windows.h>
#endif


namespace INdepUmi100 {

  /*
   * User/Kernel Umi
   */
  class UmiKernel:public Umi {
    #if (defined(MMSYS_linux))
      int _fd;			/* local fd */
    #else
      HANDLE _h;			
    #endif

   public:

    Failable &putMsg(UmiControl*, const UmiData*);
    Failable &getMsg( UmiControlBuf*, UmiData *);
    Failable& xchMsg(UmiControlBuf *puc, UmiData *pud);

    #if (defined(MMSYS_linux))
      int fd() { return _fd; }
    #endif


    /*
     * UMI connected to a kernel instance of path-to-driver/chan
     * using the protocol specified by puf. 
     */
    UmiKernel(const UmiProto *puf, const char *szPath, const char *szChan);
    ~UmiKernel();
  };

  /*
   * Factory to create Kernel UMI
   */
  class FactoryKernel:public Factory {
    char *_szPath;
   public:
    /*
     * create channel to driver
     */
    virtual Failable createUmi(Umi **ppum, const UmiProto *pup, int iChan) const;

    /*
     * Kernel factory constructor, arg: path to driver node
     */
    FactoryKernel(const char *szPath);
    ~FactoryKernel();
  };

  extern Factory* ctFactKernel(const char *szMode, const char *szArg);
}


#endif
