#ifndef _UMI_UMI_L_HXX_
#define _UMI_UMI_L_HXX_ 1

/*
 * umi_l.hxx - UMI Local Interface Service Provider
 *
 * %LEGAL%
 */

#include <iostream>
#include "umic/umi_driver.hxx"
#include "umi/umi_user.hxx"



namespace INdepUmi100 {

  /*
   * Umi sync
   */
  class UmiLocal;
  class UmiSync:public UmiEnv {
   public:
    /*
     * wait until there are messages at the input queue 
     * (or timeout)
     */
    virtual void syncIn(UmiLocal *)=0;

    /*
     * wait until there is room at the output queue 
     * (or timeout)
     */
    virtual void syncOut(UmiLocal *)=0;
    virtual Time tiNext( const Time &ti )=0;

    UmiSync() { }
    virtual ~UmiSync() { }
  };

  /*
   * Local Umi
   */
  class UmiLocal:public UmiChannel, public Umi {
    UmiSync *_pus;


    UmiSync *pus() { return _pus; }

   public:

    /*
     * Umi
     */
    Failable &putMsg( UmiControl*, const UmiData* );
    Failable &getMsg( UmiControlBuf*, UmiData *);
    Failable &xchMsg( UmiControlBuf *puc, UmiData *);

    /*
     * UmiChannel
     */
    Time tiNext( const Time &ti );		


    void init(UmiSync *pus) { _pus=pus; }
    void finiPool(Link *pli);
    UmiLocal( UmiDriver *pud, int iChan, UmiProto *puf, UmiSync *pus);
    ~UmiLocal();
  };
}

#endif
