#ifndef _WIRE_HXX
#define _WIRE_HXX 1

/*
 * wire.hxx
 * marshalling/unmarshalling
 */

#ifndef _MM_NO_IOSTREAM

 #include <iostream>
 #include <sys/types.h>

  /*
   * Formatters for wire format
   */
  class xistream: /* virtual */ public std::ios {
      typedef unsigned u_int;
      std::streambuf *psb() { return rdbuf(); }

      xistream &setfailed( int fEof ) {
	 setstate(std::ios_base::failbit);
	 if (fEof) setstate(std::ios_base::eofbit);
	 return *this;
      }

    #if 0
      bool isBigEndWire() { return _fBE; }
      int iBigEndInt(u_char *pch, int iLen);
      int iLittleEndInt(u_char *pch, int iLen);
      unsigned getUnsigned(int iLen); 	
    #endif

      xistream &getInt(u_int &i, int iLen); 

    public:
      //xistream &getOct(u_char &);
      //xistream &peekInt1(u_int &);
      //xistream &getInt1(bool &f) { f=(getUnsigned(1)!=0); return *this; }
      //xistream &getInt1(char &ch) { ch=getUnsigned(1); return *this; }

      xistream &getInt1(u_int &i) { return getInt(i,1); }
      xistream &getInt2(u_int &i) { return getInt(i,2); }
      xistream &getInt4(u_int &i) { return getInt(i,4); }
      xistream &getInt4(long int &i) { u_int j; if (getInt(j,4)) i=j; return *this; }
      xistream &getInt1(bool &f) { u_int j; if (getInt(j,1)) f=(j!=0); return *this; }
      xistream &getInt1(char &ch) { u_int j; if (getInt(j,1)) ch=j; return *this; }

      //int getInt4() { u_int i; getInt(i,4); return i; }
      //xistream &getFloat4(float &r); 

      xistream (std::streambuf *);
      ~xistream ();
  };

  class xostream: /* virtual */ public std::ios 
  {
    typedef unsigned u_int;
    typedef unsigned char u_char;
    
    std::streambuf *psb() { return rdbuf(); }
    xostream &setfailed(  ) {
      setstate(failbit);
      return *this;
    }

    //bool isBigEndWire() { return _fBE; }
      
    //void makeBigEndInt(u_char *pch, int iLen, int i) ;
    //void makeLittleEndInt(u_char *pch, int iLen, int i) ;
    
    xostream &putInt(u_int i, int iLen);
    
  public:
    xostream &putOct(u_char );
    xostream &putInt1(u_int i) { return putInt(i,1); }
    xostream &putInt2(u_int i) { return putInt(i,2); }
    xostream &putInt4(u_int i) { return putInt(i,4); }
    xostream &putFloat4(float r);

    xostream &flush() { 
      rdbuf()->pubsync(); 
      return *this;
    }
    
    xostream (std::streambuf *);
    ~xostream ();
  };

 #else

  class xistream;
  class xostream;

 #endif

#endif
