
#ifndef _LUMI_H_
#define _LUMI_H_

#include <linux/version.h>
#include <linux/devfs_fs_kernel.h>
#include "umic/umi_c.h"

  struct Card ; 

  #define GETCARD(i) ((i) >> 4)
  #define GETCHAN(i) ((i) & 0xf)

  struct LumiMod {
    const char *_szDid;
    const char *_szName;
    const char *_szDvs;
    struct pci_driver *_pPdr;
    char *_szProcDir;		/* subdir of /proc/	*/
    int _cMaxCard;		/* max				*/

    int _cMaxIsa;		/* max isa cards		*/
    int *_piIoIsa;			/* ports array			*/
    int *_piIrqIsa;		/* irq array			*/

    struct UmiMod *_pum;	/* per card UmiMod		*/
    struct file_operations *_pFops;
    int * _pfDebug;

    /* init to zero */
    int _iMajor;
    struct Card *_pca;		/* array of Cards		*/
  #if LINUX_VERSION_CODE < KERNEL_VERSION(2,5,0)
    devfs_handle_t _hDfs;
  #else
    int _hDfs;
  #endif


  } ;


  extern int lumi_probe(struct LumiMod*, struct pci_dev *pdv, const struct pci_device_id *pdi);
  extern void lumi_remove(struct LumiMod*, struct pci_dev *pdv);
  extern int lumi_init_module(struct LumiMod *plm);
  extern void lumi_cleanup_module(struct LumiMod *plm);

  extern int lumi_ioctl(struct LumiMod*, struct inode * pin,struct file *fp, unsigned int cmd, unsigned long arg );
  extern int lumi_open(struct LumiMod*, struct inode * pin, struct file *fp);
  extern int lumi_release(struct LumiMod*, struct inode * pin, struct file *fp);
  extern int lumi_mmap(struct LumiMod *, struct file*pFil, struct vm_area_struct *pVma);

#endif
