
/*
 * ines Linux Gpib driver 
 * 
 */

#include <linux/init.h>
#include <linux/module.h>
#include <linux/moduleparam.h>
#include <linux/pci.h>
#include "lumi.h"
#include "gpibc/cards.h"
#include "gpibc/gumi_c.h"

int _GLOBAL_OFFSET_TABLE_;

  static struct  pci_device_id  mpPdi[]  = {
    { 0x16DA, 0x0011, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CT_GPIB_PCI_XL  },
    { 0x10E8, 0x8507, PCI_ANY_ID, PCI_ANY_ID, 0, 0, CT_GPIB_PCI },
    { 0, }
  };   


  static struct LumiMod lm;

  int ieeeopen(struct inode * pin, struct file *fp) { return lumi_open(&lm, pin, fp); }
  int ieeerelease(struct inode * pin, struct file *fp) { return lumi_release(&lm, pin, fp); }
  int ieeeioctl(struct inode * pin,struct file *fp, unsigned int cmd, unsigned long arg ) { return lumi_ioctl( &lm, pin,fp, cmd, arg ); }
  int ieeemmap(struct file*pFil, struct vm_area_struct *pVma) { return lumi_mmap( &lm, pFil, pVma); }

  static struct file_operations gpib_fops=
  {
    owner: THIS_MODULE, 
    open: ieeeopen,
    release: ieeerelease,
    ioctl: ieeeioctl,
    mmap: ieeemmap,
  };

  /*
   * announce our capabilities 
   */
  MODULE_DEVICE_TABLE(pci, mpPdi);

  static struct pci_driver pdr;

  #define MAX_ISA 4

  static int mpIoIsa[MAX_ISA];
  static int mpIrqIsa[MAX_ISA];

  MODULE_PARM(mpIoIsa,"1-" __MODULE_STRING(MAX_ISA) "i");
  MODULE_PARM(mpIrqIsa, "1-" __MODULE_STRING(MAX_ISA) "i");
  static int cIsa;

  module_param_array(mpIrqIsa, int, cIsa, 0444);
  module_param_array(mpIoIsa, int, cIsa, 0444);


  int fDebug=0;
  static struct LumiMod lm = {
    "igpib",
    "ines ieee488 GPIB",
    "6.00",
    &pdr,
    "driver/igpib",
    4,

    MAX_ISA,
    mpIoIsa,
    mpIrqIsa,

    &umGpib,
    &gpib_fops,
    &fDebug
  };

  MODULE_PARM(fDebug,"i");


  int gpib_probe(struct pci_dev *pdv, const struct pci_device_id *pdi) { return lumi_probe(&lm, pdv, pdi); }
  void gpib_remove(struct pci_dev *pdv) { return lumi_remove(&lm, pdv); }

  static struct pci_driver pdr = {
    name: 	"ieee488",
    id_table:	mpPdi,
    probe:	gpib_probe,
    remove:	gpib_remove,
    /* operations set by lumi */
  };


  static int init_gpib (void) { return lumi_init_module(&lm); }
  static void cleanup_gpib (void) { return lumi_cleanup_module(&lm); }

  module_init(init_gpib);
  module_exit(cleanup_gpib);

