#include "gpibcore.h"

/*
 *	sm.cxx
 *
 *	970827 ws 	created
 */




/*
 *	SmM
 */
int SmM::wasState(int eNew, int ePrev) {
	int f=(ePrev == _e);
	_e=eNew;
	return f;
}

SmM::SmM(int e) { _e=e; }
SmM::~SmM() {}




/*
 *	Copyright (C)  by
 *	ines GmbH 1991
 *
 *	%W%
 */





Link::Link()
{
	_chain=0;
	_next=_prev=0;			// standalone
}

Link::Link(ChainRaw* chain)
{
	_chain=0;			// Chain accept only unassigned Links 
	_next=_prev=0;			// standalone
	chain->push(this);		// append to chain( and assign )
}

Link::~Link()
{
	if (_chain) {
		_chain->remove(this);
	}
}

ChainRaw::ChainRaw()
{
	_tail=_head=0;
	_c=0;
}

ChainRaw::ChainRaw(ChainRaw *pcn)
{
	_tail=_head=0;
	_c=0;
	Link *pln;
	while((pln=pcn->pull())) this->push(pln);
}


ChainRaw::~ChainRaw() { assert(_c==0); }

void ChainRaw::import(ChainRaw *pcn) {
	Link *pln;
	while((pln=pcn->pull())) this->push(pln);
}

Link* ChainRaw::iterate( ChainIterator *pit) const
{
	Link* ret;
	ret=pit->_pliCur;
	if (ret) pit->_pliCur= (pit->_fTH) ? ret->_prev:ret->_next;
	return ret;
}

Link* ChainRaw::peek( ChainIterator *pit) const
{
	return pit->_pliCur;
}

Link *ChainRaw::head() const
{
	return _head;
}

Link *ChainRaw::tail() const
{
	return _tail;
}

Link *ChainRaw::remove(Link *l)
{
	if (!l) return l;
	assert(_c);
	assert (l->_chain==this);
	if (l->_next) l->_next->_prev = l->_prev;
	else _tail=l->_prev;
	if (l->_prev) l->_prev->_next = l->_next;
	else _head=l->_next;
	l->_chain=0;
	l->_next=l->_prev=0;	/* isolate Link	*/
	_c--;
	return l;
}

/*
 *	put 'nel' behind 'l' in Chain
 */

Link *ChainRaw:: put(Link* l, Link*nel)
{
	if (l) assert(l->_chain == this);
	if (nel->_chain) return 0;		// must be a new link
	else nel->_chain=this;			// ... init

	if (l) {
		/*
		 *	append to element l
		 */

		if (l->_next) l->_next->_prev =nel;
		else _tail=nel;
		nel->_next=l->_next;
		l->_next=nel;
		nel->_prev=l;
	}
	else {
		/*
		 * 	append to 0'th position (put as first element)
		 */
		nel->_prev = 0;
		nel->_next = _head;
		_head= nel;
		if (nel->_next) nel->_next->_prev=nel;
		else _tail = nel;
	}		
	_c++;
	return nel;
}	

int ChainRaw::get(Link **ppl, int c) {
	int i;
	Link *pl;
	ChainIterator it;

	strtIter(&it);
	i=0;

	while((pl=iter(&it)) && i<c ) {
		*(ppl++)=pl;
		i++;
	}

	return i;
}

Link *ChainRaw::get(int iPos) const {
	int i;
	Link *pl;
	ChainIterator it;

	strtIter(&it);
	i=0;

	while((pl=iter(&it)) && i<iPos ) {
		i++;
	}
	return pl;
}

int ChainRaw::pos(const Link *pln) const {
	int i;
	Link *pl;
	ChainIterator it;

	strtIter(&it);
	i=0;

	while((pl=iter(&it)) && pl != pln ) {
		i++;
	}
	return pl ? i : -1;
}
	


LiLink *LiLink::append(LiLink *pllNew) {
	assert(pllNew->_pllNext == 0 && pllNew->_pllPrev == 0);

	
	pllNew->_pllNext = this->_pllNext;
	if (pllNew->_pllNext) pllNew->_pllNext->_pllPrev = pllNew;
	pllNew->_pllPrev = this;
	this->_pllNext=pllNew;
	return pllNew;
}

LiLink *LiLink::insert(LiLink *pllNew) {
	assert(pllNew->_pllNext == 0 && pllNew->_pllPrev == 0);
	
	pllNew->_pllPrev = this->_pllPrev;
	if (pllNew->_pllPrev) pllNew->_pllPrev->_pllNext = pllNew;
	pllNew->_pllNext = this;
	this->_pllPrev=pllNew;
	return pllNew;
}

LiLink *LiLink::remove() {
	if (this->_pllPrev) {
		this->_pllPrev->_pllNext = this->_pllNext;
	}
	if (this->_pllNext) {
		this->_pllNext->_pllPrev = this->_pllPrev;
	}
	this->_pllNext=this->_pllPrev=0;
	return this;
}

LiLink::LiLink() { _pllNext=_pllPrev=0; }
LiLink::~LiLink() {
	/* deleted link should be removed from list */
	assert(_pllNext == 0 && _pllPrev == 0);	
};

LiChain::LiChain() { _pllHead=_pllTail=0; }
LiChain::~LiChain() {}
	
LiLink *LiChain::appendTail(LiLink *pll) {
	assert(pll->isIsol());

	if (!_pllTail) {	
		/* empty */
		assert(!_pllHead);
		_pllTail=_pllHead=pll;
	}
	else {
		_pllTail=_pllTail->append(pll);
	}
	return pll;
}

LiLink *LiChain::remove(LiLink*pll) {
	if (pll == _pllHead) {
		_pllHead=pll->pllNext();
	}
	if (pll == _pllTail) {
		_pllTail=pll->pllPrev();
	}
	return pll->remove();
}

LiLink *LiChain::removeHead() {
	if (!_pllHead) return 0;
	else return remove(_pllHead);
}

LiLiPl::LiLiPl(void *p) { 
	assert(p);		/* Null required for end-of-list */
	_pv=p; 
} 
LiLiPl::~LiLiPl() {}

 #ifndef _MM_NO_IOSTREAM
  std::ostream &operator<<(std::ostream &os, const Failable &fa) {
    os << "stat=" ;
    switch (fa._eStat) {
     case fa.E_OK:
      os << "good";
      break;
     case fa.E_FAIL:
      os << "fail";
      break;
     case fa.E_BAD:
      os << "bad";
      break;
     default:
      os << std::hex << fa._eStat;
    }

    os << " (";
    if (fa._szErr) os << fa._szErr;
    os <<  ") ";
    os << std::dec << fa._iErr;
    return os;
  }
 #endif

  int Failable::print(char *sz, unsigned size) const {
    return sprintf(sz, "stat=%x (%s %d)", _eStat, _szErr ? _szErr : "-nil-", _iErr);
  }

  Failable& Failable::setStat(Failable::StatE eStat, const char *sz, int i) {
    _szErr=sz;
    _iErr=i;
    _eStat=eStat;
    return *this;
  }

  Failable& Failable::setStat(const Failable &fa) {
    _szErr=fa._szErr;
    _iErr=fa._iErr;
    _eStat=fa._eStat;
    return *this;
  }

  Failable::Failable() : _eStat(E_OK), _iErr(0), _szErr(0) {}
  Failable::~Failable() {  }



#ifndef _MM_NO_IOSTREAM
std::ostream &operator<<(std::ostream&os, const Counter &ct) {
	if (!ct.isOverflow()) {
	    os << ct._c << '/' << ct._n;
	    if (ct._n) os << '(' << double(ct._c)/double(ct._n) << ')';
	}
	else os << "####";
	return os;
}
#endif 

void Counter::sample(unsigned n) { 
    if (!isOverflow()) {
	_n++; 
	if (_n == 0) setOverflow();

	_c+=n; 
	if (_c < n) setOverflow();
    }
}
Counter::Counter():_fOverflow(false), _c(0), _n(0) { }
Counter::~Counter() {  }


#ifndef _MM_NO_IOSTREAM
#endif

namespace INdepUmi100 {

 #if 0
  bool operator>=( const Time &tiL, const Time &tiR ) { 
    assert(tiL._iHz == tiR._iHz); 
    return tiL._i >= tiR._i; 
  }

  UmiData& UmiData::operator=(const UmiDataStruct &ud) {
    const int c(ud._pchLimDat - ud._pchBase);

    assert(_pchBase && _pchLimBuf-_pchBase >= c);
    memcpy(_pchBase, ud._pchBase, c );
    _pchLimDat=_pchBase + c;
    return *this;
  }
 #endif

  bool operator>=( const Time &tiL, const Time &tiR ) { 
    return  ((tiL.tv_sec > tiR.tv_sec) || ((tiL.tv_sec == tiR.tv_sec) && (tiL.tv_nsec >= tiR.tv_nsec)));
  }

  Time operator+( const Time &tiL, const Time &tiR  ) {
    Time ti;

    ti.tv_sec=tiL.tv_sec+tiR.tv_sec;
    ti.tv_nsec=tiL.tv_nsec+tiR.tv_nsec;
    if (ti.tv_nsec >= 1000000000) {
      /* normalize */
      ti.tv_sec++;
      ti.tv_nsec -= 1000000000;
    }
    return ti;
  }

  UmiControlBuf& UmiControlBuf::operator=(const UmiControl &uc) {
    assert( uc._size <= sizeof(*this));
    memcpy(this, &uc, uc._size);
    return *this;
  }
  UmiControlBuf::UmiControlBuf():UmiControl(0,sizeof(*this)) {
   #ifndef NDEBUG
    memset(_mpch, 0xa5, sizeof(_mpch));
   #endif
  }
  UmiControlBuf::~UmiControlBuf() {}


 #ifndef _MM_NO_IOSTREAM

  std::ostream &operator<<(std::ostream &os, const Time &ti) { return os << std::dec << ti.tv_sec << ':' << ti.tv_nsec ;  }

   std::ostream &operator<<(std::ostream &os, const UmiControl &uc) {
     return os << std::hex << "type=" << uc.eType();
   }

 #endif
}


namespace INdepUmi100 {

  UmiMsgDownBuf::UmiMsgDownBuf():UmiGetBuf(_mpchData, SZ_DATA_MAX) {
    #ifndef NDEBUG
      memset(_mpchData, 0xa5, sizeof(_mpchData));
    #endif
    init(this, this);
  }
  UmiMsgDownBuf::~UmiMsgDownBuf() { }

  UmiMsgUpBuf::UmiMsgUpBuf():UmiPutBuf(_mpchData, SZ_DATA_MAX) {

    #ifndef NDEBUG
      memset(_mpchData, 0xa5, sizeof(_mpchData));
    #endif

    init(this, this);
  }
  UmiMsgUpBuf::~UmiMsgUpBuf() { }

  /*
   * copy up data to user space
   */
  void copy(UmiData *pud, const UmiMsgUpBuf*pmu) {
    const int c(pmu->cDone());
    if (c) {
      assert (pud->_pchBase && c <= pud->_pchLimBuf-pud->_pchBase);
      memcpy(pud->_pchBase, pmu->pchBase(), c );
    } 
    pud->_pchLimDat=pud->_pchBase + c;
  }

  /*
   * copy down to driver space
   */
  void copy(UmiMsgDownBuf*pum, const UmiData*pud) {
    const int c(pud->cData());
    assert (pum->pchBase() && c <= pum->cMax());
    memcpy(const_cast<char*>(pum->pchBase()), pud->pchBase(), c );
    pum->setCount(c);
  }

  void UmiEnv::sigGet( int, void * ) {}
  void UmiEnv::sigPut( int, void * ) {}

  /*
   * UmiChannel driver services
   */
  void UmiChannel::putUp(int iCtx, Pmu pmu ) {
    assert(pmu);
    assert(pmu->chain());
    assert(pmu->chain() == pcnUmuDriver()); 	/* must be allocated */
    //printQueues(std::cerr << "putUp ") << std::endl;
    pcnUmuQueue()->import(const_cast<UmiMsgUp*>(pmu));
    pue()->sigGet(iCtx, _phEnv);
  }

  Pmu UmiChannel::allocUpForced(size_t sDataMax) {
    if (!pcnUmuPool()->head()) {
      /* delete last message */
      pcnUmuPool()->import(pcnUmuQueue()->tail());
    }
    return allocUp(sDataMax);
  }

  Pmu UmiChannel::allocUp(size_t sDataMax) {
    if (!pcnUmuPool()->head()) return 0;
    assert(sDataMax <= SZ_DATA_MAX);
    //printQueues(std::cerr << "allocUp ") << std::endl;

    UmiMsgUpBuf* pUmu=static_cast<UmiMsgUpBuf*>(pcnUmuPool()->pop());
    pcnUmuDriver()->push(pUmu);
    pUmu->setLimit(sDataMax);
    return pUmu;
  }

  void UmiChannel::releaseDown(int iCtx, Pmd pmd) {

    /* release  message */
    assert(pmd->chain() == pcnUmdDriver());
    pcnUmdPool()->import(const_cast<UmiMsgDown*>(pmd));

    /* channel release, check queue for more messages */

    if (pcnUmdQueue()->head()) {
      UmiMsgDown *pUmd=static_cast<UmiMsgDown*>(pcnUmdQueue()->pull());
      pcnUmdDriver()->push(pUmd);
      (void)this->pud()->putDown(iCtx, pUmd, iChan());
    }
    pue()->sigPut(iCtx, _phEnv);
  }

  Pmu UmiChannel::allocUp(size_t sData, Pmd pmd) {
    /* reuse message */
    return allocUp(sData);
  }

  UmiMsgDownBuf* UmiChannel::allocDownBuf() { 
    if (!pcnUmdPool()->head()) return 0;
    UmiMsgDownBuf* pUmd=static_cast<UmiMsgDownBuf*>(pcnUmdPool()->pop()); 
    pcnUmdUser()->push(pUmd);
    return pUmd;
  }

  void UmiChannel::putDownBuf(int iCtx, UmiMsgDownBuf *pUmd) {
    assert(pUmd->chain() == pcnUmdUser());
    if (!pcnUmdDriver()->head()) {

      /* driver channel ready */
      pcnUmdDriver()->import(pUmd);
      (void)this->pud()->putDown(iCtx, pUmd, iChan());
    }
    else {
      /* driver channel busy */
      pcnUmdQueue()->import(pUmd);
    }
  }

  UmiMsgUpBuf* UmiChannel::getUpBuf() {
    if (!pcnUmuQueue()->head()) return 0;

    UmiMsgUpBuf* pUmu=static_cast<UmiMsgUpBuf*>(pcnUmuQueue()->pull());
    pcnUmuUser()->push(pUmu);
    return pUmu;
  }

  /*
   * upstream message return from user. If we were out
   * of buffers, back-enable the driver.
   */
  void UmiChannel::releaseUpBuf(int iCtx, UmiMsgUpBuf *pUmu) {
    assert(pUmu->chain() == pcnUmuUser());
    bool fWasEmpty(!pcnUmuPool()->head());
    pcnUmuPool()->import(pUmu);
    if (fWasEmpty) pud()->backenable(iCtx, iChan());
  }

  int UmiChannel::open() { 
    return pud()->open(iChan());
  }

  void UmiChannel::close() { 
    pud()->close(iChan());
    finiQueues();
  }

 #ifndef _MM_NO_IOSTREAM
  std::ostream &UmiChannel::printQueues(std::ostream &os) const {
    /* delete from all chains */
    os << " dq=" << _cnUmdQueue.count();
    os << " dd=" << _cnUmdDriver.count();
    os << " dp=" << _cnUmdPool.count();
    os << " uq=" << _cnUmuQueue.count();
    os << " ud=" << _cnUmuDriver.count();
    os << " up=" << _cnUmuPool.count();
    return os;
  }
 #endif


  void UmiChannel::finiPool(Link *pli) {  }

  void UmiChannel::finiQueues() {

    _cnUmdPool.import(&_cnUmdQueue); 
    _cnUmdPool.import(&_cnUmdDriver); 
    _cnUmdPool.import(&_cnUmdUser); 

    _cnUmuPool.import(&_cnUmuQueue); 
    _cnUmuPool.import(&_cnUmuDriver); 
    _cnUmuPool.import(&_cnUmuUser); 
  }

  void UmiChannel::finiPools() {
    ChainIterator it;
    Link *pli;

    _cnUmdPool.strtIter(&it);
    while ( ( pli = _cnUmdPool.iter(&it)) ) finiPool(pli);

    _cnUmuPool.strtIter(&it);
    while ( (pli = _cnUmuPool.iter(&it)) ) finiPool(pli);
  }

  const UmiProto *UmiChannel::pup() { return _pud->pup(_iChan); }
  UmiChannel::UmiChannel(UmiDriver *pud, int iChan, UmiEnv *pue):_pud(pud), _pue(pue), _iChan(iChan), _phEnv(0) {}
  UmiChannel::~UmiChannel() {}


  void UmiDriver::backenable(int iCtx, int iChan) { }
  int UmiDriver::open(int iChan) { return 0; }
  void UmiDriver::close(int iChan) {  }
  char *UmiDriver::print( char *pch, int i ) {
    if (i) strcpy(pch, "");
    return pch;
  }
  UmiDriver::UmiDriver(const char *szName, UmiCard *pca): _szName(szName), _pca(pca) {}
  UmiDriver::~UmiDriver() { }
}


    

namespace INdepUmi100 {

  Umi::Umi(const UmiProto *puf):_puf(puf) { }
  Umi::~Umi() {}
  bool Umi::canPut() { return true; }

  Failable &Umi::xchMsg(UmiControlBuf *puc, UmiData *pud) {
    if (putMsg(puc, pud)) getMsg(puc, pud);
    return *this;
  }

}


#ifdef MMCCS_gcc3
void operator delete(void*) {}
#endif 

namespace INdepUmi100 {

  int UmiMod_getMem(struct UmiMod*, struct UmiMemInfo *, int) {
   return 0;
  }

  Time UmiEnvRed::tiNext( const Time &ti ) { 
    Time tiNow;
    (*_pueC->_pFtiNextTick)(&tiNow);
    return tiNow+ti;
  }

  void UmiEnvRed::sigGet( int i, void *p ) { (*_pueC->_pFsigGet)(i, p); }
  void UmiEnvRed::sigPut( int i, void *p ) { (*_pueC->_pFsigPut)(i, p); }
  UmiEnvRed::UmiEnvRed(const UmiEnvC *pueC):_pueC(pueC) {}
  UmiEnvRed::~UmiEnvRed() {}



extern "C" {


  #ifdef __KERNEL__
    int _Unwind_Resume;
    int __cxa_pure_virtual;
    int __pure_virtual;
    int __gxx_personality_v0;
  #endif


  


  int UmiCard_timer( class UmiCard*pca, int iCtx, const struct timespec *pts) { return pca->timer(iCtx, *pts); }
  int UmiCard_interrupt( class UmiCard*pca, int iCtx ) { return pca->interrupt(iCtx); }

  void UmiCard_startIterDrivers( class UmiCard*pca, struct UmiIter *pit) { pca->startIterDrivers((ChainIter*)pit); }
  UmiDriver *UmiCard_iterateDrivers( class UmiCard*pca, struct UmiIter *pit) { return pca->iterDrivers((ChainIter*)pit); }
  const char * UmiDriver_szName( UmiDriver *p) { return (p)->szName(); }
  char * UmiDriver_print( UmiDriver *p, char *pch, int i ) { return (p)->print(pch, i); }

  void UmiDriver_startIterChannels( class UmiDriver*pud, struct UmiIter *pit) { pud->startIterChannels((ChainIter*)pit); }
  UmiChannel *UmiDriver_iterateChannels( class UmiDriver*pud, struct UmiIter *pit) { return pud->iterChannels((ChainIter*)pit); }
  int UmiChannel_num( class UmiChannel *p) { return (p)->iChan(); }
  int UmiChannel_open( class UmiChannel *puc) { return puc->open(); }
  void UmiChannel_close( class UmiChannel *puc) { puc->close(); }
  const char* UmiChannel_szProto( struct UmiChannel * puc) { return puc->pup()->szProto(); }
  void UmiChannel_setHandle( class UmiChannel *puc, void *p) { puc->setHandle(p); }

  int UmiChannel_canput( class UmiChannel *puc) { return puc->pollOut(); }
  int UmiChannel_canget( class UmiChannel *puc) { return puc->pollIn();  }

  class UmiMsgUpBuf *UmiChannel_getUpBuf( class UmiChannel *puc) { return puc->getUpBuf(); }
  void UmiChannel_releaseUpBuf( class UmiChannel *puc, int iCtx, UmiMsgUpBuf *pUmu ) { return puc->releaseUpBuf(iCtx, pUmu); }

  class UmiMsgDownBuf *UmiChannel_allocDownBuf( class UmiChannel *puc) { return puc->allocDownBuf(); }
  void UmiChannel_putDownBuf( class UmiChannel *puc, int iCtx, class UmiMsgDownBuf *pUmd) { puc->putDownBuf( iCtx, pUmd ); }

  struct UmiControlStruct * UmiMsgDownBuf_pControl(class UmiMsgDownBuf *pUmd) { return const_cast<UmiControl*>(pUmd->puc()); }
  char * UmiMsgDownBuf_pData(class UmiMsgDownBuf *pUmd) { return const_cast<char*>(pUmd->pug()->pchBase()); }
  void UmiMsgDownBuf_setDataLim(class UmiMsgDownBuf *pUmd, size_t s) { pUmd->pug()->setCount(s);  }
  size_t UmiMsgDownBuf_sizeDataMax(class UmiMsgDownBuf *pUmd) { return pUmd->pug()->cMax(); }

  struct UmiControlStruct * UmiMsgUpBuf_pControl(class UmiMsgUpBuf *pUmu) { return (pUmu->puc()); }
  size_t UmiMsgUpBuf_sizeControl(class UmiMsgUpBuf *pUmu) { return (pUmu->puc()->_size); }
  char * UmiMsgUpBuf_pData(class UmiMsgUpBuf *pUmu) { return (pUmu->pup()->pchBase()); }
  size_t UmiMsgUpBuf_sizeData(class UmiMsgUpBuf *pUmu) { return pUmu->pup()->cDone(); }

}
}

#ifdef __cplusplus 
extern "C" {
#endif

  const char *mpszGcArch[CNT_GCA] = { "7210", "72010", "72130", "9914" };

  const struct CardType mpct[CNT_CARDTYPES+1] = {
    { CT_GPIB_PCI_XL, "GPIB-PCI-XL", "72130", GCA_GP5130, 'p' , 0,
      { 
	{ 0, RG_IOMEM, 0x4000 }, 
	{ 1, RG_IOBASE, 32 }
      } 
    },
    { CT_GPIB_PCI, "GPIB-PCI",  "72010", GCA_72010, 'p' , 0, 
      { 
	{ 0, RG_AMCC5920_CONF, 128 } ,
        { 1, RG_IOBASE, 32 } 
      } 
    },
    { CT_GPIB_PC104, "GPIB-PC104",  "72010",  GCA_72010, 'i', 32,
      { { 0, RG_IOBASE, 32 } , {0, 0, 0 } } 
    },
    { CT_GPIB_PCMCIA, "GPIB-PCMCIA", "72010",  GCA_72010, 'P', 32,
      { { 0, RG_IOBASE, 32 } , {0, 0, 0 } } 
    },
    { CT_GPIB_PC, "GPIB-PC", "7210",  GCA_7210, 'i', 8,
      { { 0, RG_IOBASE, 8 } , {0, 0, 0 } } 
    },
    { -1, 0, 0, GcArchE(0), 0, 0, 
      { { 0, 0, 0 } , {0, 0, 0 } } 
    }
  };

  const RegionDesc *getRegionBySize(const struct CardType *pct, int len) {
   for (int i=0; i<MAX_REGION; i++) if (pct->_mprd[i]._l == len) return pct->_mprd+i;
   return 0;
  }

#ifdef __cplusplus 
}
#endif
/*
 * This file is automatically created
 * DO NOT EDIT
 */
namespace INdepGpib100 {



  /*
   * class GpibIfConf
   */
  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibIfConf&cor) { 
      os << ' ' << "fSc=" << cor._fSc;
      os << ' ' << "iPa=" << cor._iPa;
      os << ' ' << "fSa=" << cor._fSa;
      os << ' ' << "iSa=" << cor._iSa;
      return os;
    }
  #endif


  /*
   * class GpibTermOut
   */
  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibTermOut&cor) { 
      os << ' ' << "chEos=" << cor._chEos;
      os << ' ' << "fEnd=" << cor._fEnd;
      os << ' ' << "fEoiEos=" << cor._fEoiEos;
      os << ' ' << "fEos7=" << cor._fEos7;
      os << ' ' << "fHighSpeed=" << cor._fHighSpeed;
      return os;
    }
  #endif


  /*
   * class GpibTermIn
   */
  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibTermIn&cor) { 
      os << ' ' << "cEos=" << cor._cEos;
      os << ' ' << "fDelEnd=" << cor._fDelEnd;
      os << ' ' << "fEos7=" << cor._fEos7;
      os << ' ' << "chEos=";      for(int i=0; i<3;i++)       os << ' ' <<  cor._mpchEos[i];
      return os;
    }
  #endif


  /*
   * class GpibTrf
   */
  GpibTrf::GpibTrf(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibTrf)),_iTrans(0),_fLast(false) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibTrf&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "tiTmo=" << cor._tiTmo;
      os << ' ' << "iTrans=" << cor._iTrans;
      os << ' ' << "fLast=" << cor._fLast;
      return os;
    }
  #endif
  GpibTrf* pGpibTrf(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x1);
    return static_cast<GpibTrf*>(puc);
  }


  /*
   * class GpibCmd
   */
  GpibCmd::GpibCmd(int e, size_t s):GpibTrf(e, s ? s : sizeof(GpibCmd)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibCmd&cor) { 
      os << (const GpibTrf&)cor;
      return os;
    }
  #endif
  GpibCmd* pGpibCmd(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x3);
    return static_cast<GpibCmd*>(puc);
  }


  /*
   * class GpibCwr
   */
  GpibCwr::GpibCwr(int e, size_t s):GpibTrf(e, s ? s : sizeof(GpibCwr)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibCwr&cor) { 
      os << (const GpibTrf&)cor;
      os << ' ' << "termOut=" << cor._termOut;
      return os;
    }
  #endif
  GpibCwr* pGpibCwr(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x5);
    return static_cast<GpibCwr*>(puc);
  }


  /*
   * class GpibCrd
   */
  GpibCrd::GpibCrd(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibCrd)),_cMax(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibCrd&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "termIn=" << cor._termIn;
      os << ' ' << "tiTmo=" << cor._tiTmo;
      os << ' ' << "cMax=" << cor._cMax;
      return os;
    }
  #endif
  GpibCrd* pGpibCrd(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x8);
    return static_cast<GpibCrd*>(puc);
  }


  /*
   * class GpibInit
   */
  GpibInit::GpibInit(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibInit)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibInit&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "ifConfig=" << cor._ifConfig;
      return os;
    }
  #endif
  GpibInit* pGpibInit(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x10);
    return static_cast<GpibInit*>(puc);
  }


  /*
   * class GpibFini
   */
  GpibFini::GpibFini(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibFini)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibFini&cor) { 
      os << (const Umi::UmiControl&)cor;
      return os;
    }
  #endif
  GpibFini* pGpibFini(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x20);
    return static_cast<GpibFini*>(puc);
  }


  /*
   * class GpibResp
   */
  GpibResp::GpibResp(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibResp)),_eErr(0),_iErr(0),_fStat(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibResp&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "eErr=" << cor._eErr;
      os << ' ' << "iErr=" << cor._iErr;
      os << ' ' << "fStat=" << cor._fStat;
      return os;
    }
  #endif
  GpibResp* pGpibResp(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x40);
    return static_cast<GpibResp*>(puc);
  }


  /*
   * class GpibRdResp
   */
  GpibRdResp::GpibRdResp(int e, size_t s):GpibResp(e, s ? s : sizeof(GpibRdResp)),_fDel(false),_fDelEnd(false) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibRdResp&cor) { 
      os << (const GpibResp&)cor;
      os << ' ' << "fDel=" << cor._fDel;
      os << ' ' << "fDelEnd=" << cor._fDelEnd;
      return os;
    }
  #endif
  GpibRdResp* pGpibRdResp(Umi::UmiControl *puc) {
    assert(puc->eType() & 0xc0);
    return static_cast<GpibRdResp*>(puc);
  }


  /*
   * class GpibWrResp
   */
  GpibWrResp::GpibWrResp(int e, size_t s):GpibResp(e, s ? s : sizeof(GpibWrResp)),_cTrans(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibWrResp&cor) { 
      os << (const GpibResp&)cor;
      os << ' ' << "cTrans=" << cor._cTrans;
      return os;
    }
  #endif
  GpibWrResp* pGpibWrResp(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x140);
    return static_cast<GpibWrResp*>(puc);
  }


  /*
   * class GpibInfo
   */
  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibInfo&cor) { 
      os << ' ' << "eArch=" << cor._eArch;
      os << ' ' << "cIntr=" << cor._cIntr;
      return os;
    }
  #endif


  /*
   * class GpibInfoResp
   */
  GpibInfoResp::GpibInfoResp(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibInfoResp)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibInfoResp&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "info=" << cor._info;
      return os;
    }
  #endif
  GpibInfoResp* pGpibInfoResp(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x200);
    return static_cast<GpibInfoResp*>(puc);
  }


  /*
   * class GpibIfc
   */
  GpibIfc::GpibIfc(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibIfc)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibIfc&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "ti=" << cor._ti;
      return os;
    }
  #endif
  GpibIfc* pGpibIfc(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x400);
    return static_cast<GpibIfc*>(puc);
  }


  /*
   * class GpibWait
   */
  GpibWait::GpibWait(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibWait)),_fStat(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibWait&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "ti=" << cor._ti;
      os << ' ' << "fStat=" << cor._fStat;
      return os;
    }
  #endif
  GpibWait* pGpibWait(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x800);
    return static_cast<GpibWait*>(puc);
  }


  /*
   * class GpibRen
   */
  GpibRen::GpibRen(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibRen)),_fSet(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibRen&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "fSet=" << cor._fSet;
      return os;
    }
  #endif
  GpibRen* pGpibRen(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x1000);
    return static_cast<GpibRen*>(puc);
  }


  /*
   * class GpibSta
   */
  GpibSta::GpibSta(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibSta)),_iStb(0),_fMss(0),_fNew(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibSta&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "iStb=" << cor._iStb;
      os << ' ' << "fMss=" << cor._fMss;
      os << ' ' << "fNew=" << cor._fNew;
      return os;
    }
  #endif
  GpibSta* pGpibSta(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x2000);
    return static_cast<GpibSta*>(puc);
  }


  /*
   * class GpibLnReq
   */
  GpibLnReq::GpibLnReq(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibLnReq)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibLnReq&cor) { 
      os << (const Umi::UmiControl&)cor;
      return os;
    }
  #endif
  GpibLnReq* pGpibLnReq(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x4000);
    return static_cast<GpibLnReq*>(puc);
  }


  /*
   * class GpibLnResp
   */
  GpibLnResp::GpibLnResp(int e, size_t s):GpibResp(e, s ? s : sizeof(GpibLnResp)),_fCap(0),_fStat(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibLnResp&cor) { 
      os << (const GpibResp&)cor;
      os << ' ' << "fCap=" << cor._fCap;
      os << ' ' << "fStat=" << cor._fStat;
      return os;
    }
  #endif
  GpibLnResp* pGpibLnResp(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x8040);
    return static_cast<GpibLnResp*>(puc);
  }


  /*
   * class GpibPeek
   */
  GpibPeek::GpibPeek(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibPeek)),_iPort(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibPeek&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "iPort=" << cor._iPort;
      return os;
    }
  #endif
  GpibPeek* pGpibPeek(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x10000);
    return static_cast<GpibPeek*>(puc);
  }


  /*
   * class GpibPoke
   */
  GpibPoke::GpibPoke(int e, size_t s):GpibPeek(e, s ? s : sizeof(GpibPoke)),_iVal(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibPoke&cor) { 
      os << (const GpibPeek&)cor;
      os << ' ' << "iVal=" << cor._iVal;
      return os;
    }
  #endif
  GpibPoke* pGpibPoke(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x30000);
    return static_cast<GpibPoke*>(puc);
  }


  /*
   * class GpibNop
   */
  GpibNop::GpibNop(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibNop)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibNop&cor) { 
      os << (const Umi::UmiControl&)cor;
      return os;
    }
  #endif
  GpibNop* pGpibNop(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x40000);
    return static_cast<GpibNop*>(puc);
  }


  /*
   * class GpibDeviceStatus
   */
  GpibDeviceStatus::GpibDeviceStatus(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibDeviceStatus)),_fStat(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceStatus&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "fStat=" << cor._fStat;
      return os;
    }
  #endif
  GpibDeviceStatus* pGpibDeviceStatus(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x80000);
    return static_cast<GpibDeviceStatus*>(puc);
  }


  /*
   * class GpibDeviceInput
   */
  GpibDeviceInput::GpibDeviceInput(int e, size_t s):GpibDeviceStatus(e, s ? s : sizeof(GpibDeviceInput)),_fEND(false) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceInput&cor) { 
      os << (const GpibDeviceStatus&)cor;
      os << ' ' << "fEND=" << cor._fEND;
      return os;
    }
  #endif
  GpibDeviceInput* pGpibDeviceInput(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x180000);
    return static_cast<GpibDeviceInput*>(puc);
  }


  /*
   * class GpibDeviceEvent
   */
  GpibDeviceEvent::GpibDeviceEvent(int e, size_t s):GpibDeviceStatus(e, s ? s : sizeof(GpibDeviceEvent)),_eEvent(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceEvent&cor) { 
      os << (const GpibDeviceStatus&)cor;
      os << ' ' << "eEvent=" << cor._eEvent;
      return os;
    }
  #endif
  GpibDeviceEvent* pGpibDeviceEvent(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x280000);
    return static_cast<GpibDeviceEvent*>(puc);
  }


  /*
   * class GpibDeviceOutput
   */
  GpibDeviceOutput::GpibDeviceOutput(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibDeviceOutput)),_fEND(false) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceOutput&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "fEND=" << cor._fEND;
      return os;
    }
  #endif
  GpibDeviceOutput* pGpibDeviceOutput(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x400000);
    return static_cast<GpibDeviceOutput*>(puc);
  }


  /*
   * class GpibDeviceInitAck
   */
  GpibDeviceInitAck::GpibDeviceInitAck(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibDeviceInitAck)) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceInitAck&cor) { 
      os << (const Umi::UmiControl&)cor;
      return os;
    }
  #endif
  GpibDeviceInitAck* pGpibDeviceInitAck(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x800000);
    return static_cast<GpibDeviceInitAck*>(puc);
  }


  /*
   * class GpibDeviceStatusReport
   */
  GpibDeviceStatusReport::GpibDeviceStatusReport(int e, size_t s):Umi::UmiControl(e, s ? s : sizeof(GpibDeviceStatusReport)),_fStb(0),_fSre(0),_fForce(0) { }

  #ifndef _MM_NO_IOSTREAM
    std::ostream& operator<<(std::ostream &os, const GpibDeviceStatusReport&cor) { 
      os << (const Umi::UmiControl&)cor;
      os << ' ' << "fStb=" << cor._fStb;
      os << ' ' << "fSre=" << cor._fSre;
      os << ' ' << "fForce=" << cor._fForce;
      return os;
    }
  #endif
  GpibDeviceStatusReport* pGpibDeviceStatusReport(Umi::UmiControl *puc) {
    assert(puc->eType() & 0x1000000);
    return static_cast<GpibDeviceStatusReport*>(puc);
  }

  Gpib_gco0_Proto::Gpib_gco0_Proto():Umi::UmiProto(PROTID_gco0) {}
  Gpib_gco0_Proto::~Gpib_gco0_Proto() {}

  Gpib_gti0_Proto::Gpib_gti0_Proto():Umi::UmiProto(PROTID_gti0) {}
  Gpib_gti0_Proto::~Gpib_gti0_Proto() {}

  Gpib_gdi0_Proto::Gpib_gdi0_Proto():Umi::UmiProto(PROTID_gdi0) {}
  Gpib_gdi0_Proto::~Gpib_gdi0_Proto() {}
}


namespace INdepGpib100 {

  const bool GifCard::mpfIma[CNT_GCA][16]={
    /* GCA_7210 */
    { 0, 1, 1, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0 },
    /* GCA_72010 */
    { 0, 1, 1, 0, 0, 0, 0, 0,  0, 1, 1, 0, 0, 0, 0, 0 },
    /* GCA_72130 */
    { 0, 1, 1, 0, 0, 0, 0, 0,  0, 1, 0, 1, 0, 0, 0, 0 },
    /* GCA_9914 */
    { 0, 0, 0, 0, 0, 0, 0, 0,  0, 0, 0, 0, 0, 0, 0, 0 }
  };


 #ifdef DEBUG
  bool GifCard::getIsChange() {
    bool f(memcmp(_mpis, _mpisRef, sizeof(_mpis)));
    memcpy(_mpisRef, _mpis, sizeof(_mpis));
    return f;
  }
 #endif

  int GifCard::reset(bool fSc) {
    _fSc=fSc;

    /* clear the shadow registers */
    for (int i=0;i<MAX_IREG;i++) _mpis[i]=0;
    for (int i=0;i<MAX_REG;i++) _mpor[i]=0;
    for (int i=0;i<MAX_AUX;i++) _mpoa[i]=0;

    /* reset chip */
    write(IGC_AUXMOD, IGC_AUXCMD_RES);

    /* init nec7210 registers */
    write(IGC_I1, 0);    /* no ints */
    write(IGC_I2, 0);    /* no ints */

    if (isiGpib()) {
      write(IGC_AUXMOD, IGC_AUXCMD_XMOD); // switch to extended mode again
      write(IGC_I3, 0);
      write(IGC_I4, 0);
    }
    else if (isQuick()) {
    }

    static unsigned char mpucRegsDef[8]= { 0, 0, 0, 0, 0, 0, 0, 0 };
    static unsigned char mpucMask[8]= { 0xff, 0xff, 0xff, 0xff, 0x0, 0x0, 0xff, 0xff };
    static unsigned char mpucMask7210[8]= { 0, 0xff, 0xff, 0, 0, 0, 0, 0 };

    unsigned char *pucVal=mpucRegsDef;
    unsigned char *pucMask=(isiGpib() || isQuick()) ? mpucMask : mpucMask7210;
    for(int i=0; i<8; i++, pucVal++, pucMask++) {
      int j;

      if ((*pucVal) != ((j=read(i)) & (*pucMask))) {
	setInfo((i << 8) + j );
	return -1;
      }
    }
    setInfo(0);
    return 0;
  }

  /*
   * fill the buffer with as much as data are available
   * returns the number of bytes filled.
   */
  int GifCard::recvData(Umi::UmiPutBuf *pup, const GpibTermIn &gti, int cSpin) {
    register int c=0;

    /* REMIND: NEC 7210C delayed END handling to be implemented */
    while ((pup->canput()) && i_spin(IGC_I1, IGC_I1_DI, IGC_I1_DI, cSpin)) {
      register int ch;
      if (!(pup->canputnext())) {
        /* last byte => holdoff handshake */
	outaux(IGC_AUXOFF_AUXA, IGC_AUXA_CM, IGC_AUXA_HAM);
      }
      pup->sputc(ch=indat());
      c++;

      if (i_was(IGC_I1, IGC_I1_END)) {
        /* EIO || EOS[0]  */
	if (!gti.fDelEnd() && !gti.cEos()) i_clr(IGC_I1, IGC_I1_END);   /* ignore */
	else break;	
      }
      else if (gti.cEos() >= 2) {
	int i;
        for (i=gti.cEos()-1; i > 0; i--) if (ch == gti.chEos(i)) break;
	if (i) {
	  i_set(IGC_I1, IGC_I1_END);
	  break;
        }
      }
      /* not at end */
      if (pup->canput()) outcmd(IGC_AUXCMD_FH);
    }
    return c;
  }

  /*
   * read as much bytes as can be processed immediately from
   * the buffer and write them to the controller output fifo.
   */
  int GifCard::sendData(Umi::UmiGetBuf *pug, const GpibTermOut &gto, int cSpin) {
    int c=0;
    while (pug->sgetc() != EOF && i_spin(IGC_I1, IGC_I1_DO, IGC_I1_DO, cSpin)) {
      register int ch=pug->sbumpc_checked();
      if ((pug->sgetc() == EOF) && (gto.fEnd()) )  outcmd(IGC_AUXCMD_FEOI); 
      //std::cerr << std::hex << "send=" << ch << std::endl;
      outdat(ch);
      c++;
    }
    return c;
  }

  StatE GifCard::getStatE( ) {
    int fAs=read(IGC_ADSTS); 
    //std::cerr << "adsts=" << std::hex << f << std::endl;
    register int e=0; 

    if (fAs & IGC_ADSTS_TA) e |= F_TA;
    if (fAs & IGC_ADSTS_LA) e |= F_LA;
    if (fAs & IGC_ADSTS_CIC) e |= F_CIC;
    if (!(fAs & IGC_ADSTS_NATN)) e |= F_ATN;

    if (isSc()) e |= F_SC;

    if (i_last(IGC_I2, IGC_I2_REM)) e |= F_REM;
    if (i_last(IGC_I2, IGC_I2_LOK)) e |= F_LOK;

    if (i_was(IGC_I2, IGC_I2_SRQI)) e |= E_SRQI ;
    if (i_was(IGC_I2, IGC_I1_DET)) e |= E_DTAS ;
    if (i_was(IGC_I2, IGC_I1_DEC)) e |= E_DCAS ;

    return StatE(e);
  }

  int GifCard::interrupt(int iCtx) {
    
    /*
     * sample all possible interrupt sources,
     * do nothing if no interrupt from this card is active.
     */
    if (
      i_check(IGC_I1) | i_check(IGC_I2) | (
       isiGpib() ?  i_check(IGC_I3) | i_check(IGC_I4) : (
        isQuick() ? i_check(GP5130_RXSTS) | i_check(GP5130_WXSTS) : 0
       )
      )
    ) {
      if (pudCur()) pudCur()->interrupt(iCtx);
      /* return SILENTLY ASSUMING NO ACTIVE INT HAS BEEN READ AWAY! */
      return 1;
    }
    else return 0;
  }

  int GifCard::timer(int iCtx, const Umi::Time &ti) {
    if (pudCur()) return pudCur()->timer(iCtx, ti);
    return 0;
  }

  char * GifCard::print( char *pchBase, int s) const {
    char *pch=pchBase;
    pch += sprintf(pch, "%x ", _eInfo);
    pch += sprintf(pch, "%x/%x ", _mpis[0], _mpor[1]);
    pch += sprintf(pch, "%x/%x ", _mpis[1], _mpor[2]);
    return pch;
  }

#ifndef _MM_NO_IOSTREAM
  std::ostream &operator<< ( std::ostream &os, const GifCard &gca) {
    char mpch[80];
    gca.print(mpch, sizeof(mpch));
    return os << mpch ;
  }
#endif

  GifCard::GifCard(intptr_t addr, int eArch, int fIntr):Regs(addr), _eArch(eArch), _fSc(false), _fIntr(fIntr != 0), _eInfo(0) {
   #ifdef DEBUG
    memset(_mpisRef, 0xff, sizeof(_mpis));
   #endif

    if (isGood()) reset(false);
  }

  GifCard::~GifCard() {
    if (isGood()) reset(false);
  }
}




namespace INdepGpib100 {



  void GifControl::debug( const char *sz ) {
#ifndef _MM_NO_IOSTREAM
      std::cerr << sz << std::endl;
#endif
  }


  int GifControl::putUpResp( int iCtx, const Umi::UmiMsgDown *pmd , ErrE eErr, int iErr  ) {

    /*
     * release request, allocate responce
     */
    Umi::Pmu pmu=pcn(0)->allocUpForced(0);	/* empty data part 	*/
    assert(pmu);

    GpibResp*pmgCrr=new(pmu->puc()) GpibResp();

    pmgCrr->eErr(eErr);
    pmgCrr->iErr(iErr);
    pmgCrr->fStat(pca()->getStatE());
    pcn(0)->putUp(iCtx, pmu);
    pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    return MSG_DONE;
  }

  /*
   * initialization handler
   */
  Umi::UmiDriver::DownE GifControl::msgInit(int iCtx, Umi::Pmd pmd ) {
    const GpibInit *pmgInit=pGpibInit(pmd->puc());
    if (!isState(S_POFF)) return putUpResp(iCtx, pmd, E_STATE, __LINE__ );

    {
      const GpibIfConf &gic(pmgInit->ifConfig());

      if (
	  ( /*gic.iPa() < 0 || */ gic.iPa() > 30) || (
	    gic.fSa() && ( /* gic.iSa() < 0 || */ gic.iSa() >31 ) 
	  )
      ) return putUpResp(iCtx, pmd, E_ADR, __LINE__) ;
      else _gic=gic;
    }

    /*
     * direct interrupts to this driver
     */
    if (pca()->setDriver(this)) return putUpResp(iCtx, pmd, E_INUSE, __LINE__) ;

    if (pca()->reset(_gic.fSc())) {
      pca()->clrDriver(this);
      return putUpResp(iCtx, pmd, E_HWFAIL, __LINE__);
    }


    pca()->outreg( IGC_ADMOD, IGC_ADMOD_TRM0|IGC_ADMOD_TRM1| (gic().fSa() ? IGC_ADMOD_ADM1:IGC_ADMOD_ADM0));
    pca()->outreg( IGC_AD01, gic().iPa() );
    pca()->outreg( IGC_AD01, gic().fSa() ? ( 0x80 | gic().iSa() ) : 0xe0 );

    pca()->outaux( IGC_AUXOFF_CLK,  0xff, pca()->cNecClk() );	/* counter 	*/
    pca()->outaux( IGC_AUXOFF_WPP,  0xff, 0x10);		/* lpe false	*/
    pca()->outaux( IGC_AUXOFF_AUXA, 0xff, 0);			/* nhs mode	*/

    // FIXME when ?
    //outaux( IGC_AUXOFF_AUXB, 0xff, IGC_AUXB_INTLVL );

    pca()->outaux( IGC_AUXOFF_AUXE, 0xff, 0 );		
    pca()->outcmd( IGC_AUXCMD_IPO );	/* leave reset */

    if (pca()->isiGpib()) {
      pca()->outaux( IGC_AUXOFF_AUXF, 0xff, IGC_AUXF_RFDH );		
    }

    pca()->outreg( IGC_I1, IGC_I1_DI|IGC_I1_DO );
    pca()->outreg( IGC_I2, IGC_I2_CO|IGC_I2_SRQI );

    setTransCur(~(0));
    setState(S_IDLE);
    return putUpResp(iCtx, pmd, E_OK);
  }

  int GifControl::msgFini(int iCtx, Umi::Pmd pmd) {
    if (isState(S_POFF)) return putUpResp(iCtx, pmd, E_STATE, __LINE__ );
    assert(isGpibFini(pmd->puc()));
    int err;

    pca()->reset(false);
    err=pca()->clrDriver(this);
    assert(!err);

    setState(S_POFF);
    return putUpResp(iCtx, pmd, E_OK);
  }


  /*
   * setup error state and complete
   */
  int GifControl::putUpResp(int iCtx, Umi::Pmu pmu, GpibResp *pmg) {
    pmg->eErr(_eErr);
    pmg->iErr(_iErr);
    pmg->fStat(pca()->getStatE());
    setState(S_IDLE);
    pcn(0)->putUp(iCtx, pmu);

    Umi::Pmd pmd(_pmd); _pmd=0;
    pcn(0)->releaseDown(iCtx, pmd);		/* clear channel for next */
    return MSG_DONE;
  }

  int GifControl::hIFC(int iCtx) {
    assert(_pmd);

    /* completion variant */
    Umi::Pmu pmu;
    if ((isErr() || _fTimerDone) && (pmu=pcn(0)->allocUp(0, _pmd))) {
      pca()->outcmd(IGC_AUXCMD_CIFC);
      /* response */
      GpibResp*pmg=new(pmu->puc()) GpibResp();
      return putUpResp(iCtx, pmu, pmg);
    }
    return MSG_WAIT;
  }

  int GifControl::msgIfc( int iCtx, Umi::Pmd pmd ) {
    if (!isState(S_IDLE)) return drop(iCtx, pmd);	/* unexpected */
    if (!gic().fSc()) return failed(iCtx, pmd, E_SAC, __LINE__, &GifControl::hIFC, S_IFC );

    const GpibIfc *pmgIfc=pGpibIfc(pmd->puc());
    setState(S_IFC);
    clrErr();
    _pmd=pmd;
    _fTimerDone=0;

    pca()->outcmd(IGC_AUXCMD_SIFC);
    _tiNext=tiNext(pmgIfc->ti());
    return MSG_WAIT;
  }

  int GifControl::hREN(int iCtx) {
    assert(_pmd);

    /* completion variant */
    Umi::Pmu pmu;
    if ((isErr() || _fTimerDone) && (pmu=pcn(0)->allocUp(0, _pmd))) {
      /* response */
      GpibResp*pmg=new(pmu->puc()) GpibResp();
      return putUpResp(iCtx, pmu, pmg);
    }
    return MSG_WAIT;
  }

  int GifControl::msgRen( int iCtx, Umi::Pmd pmd ) {
    if (!isState(S_IDLE)) return drop(iCtx, pmd);	/* unexpected */
    if (!gic().fSc()) return failed(iCtx, pmd, E_SAC, __LINE__, &GifControl::hIFC, S_IFC );

    const GpibRen *pmgRen=pGpibRen(pmd->puc());
    clrErr();

    if (pmgRen->fSet()) {
      pca()->outcmd(IGC_AUXCMD_SREN);
      return putUpResp(iCtx, pmd, E_OK);
    }
    else {
      setState(S_REN);
      _pmd=pmd;
      _fTimerDone=0;
      _tiNext=tiNext(Umi::Time(0,100000));

      pca()->outcmd(IGC_AUXCMD_CREN);
      return MSG_WAIT;
    }
  }

  #if 0
  int GifControl::msgLines( int iCtx, Umi::Pmd pmd ) {
    if (isState(S_POFF)) return drop(iCtx, pmd);	/* unexpected */
    clrErr();

    

    if (pmgRen->fSet()) {
      pca()->outcmd(IGC_AUXCMD_SREN);
      return putUpResp(iCtx, pmd, E_OK);
    }
  }
  #endif


  int GifControl::hWSRQ(int iCtx) {
    assert(_pmd);

    Umi::Pmu pmu;
    if ((_fTimerDone ||  pca()->i_was(IGC_I2, IGC_I2_SRQI)) &&  (pmu=pcn(0)->allocUp(0, _pmd))) {
      /* response */
      GpibResp*pmg=new(pmu->puc()) GpibResp();
      pca()->i_clr(IGC_I2, IGC_I2_SRQI);
      if (_fTimerDone) setErr(E_TMO, __LINE__);
      return putUpResp(iCtx, pmu, pmg);
    }
    return MSG_WAIT;
  }

  int GifControl::msgWait( int iCtx, Umi::Pmd pmd ) {
    if (!isState(S_IDLE)) return drop(iCtx, pmd);	/* unexpected */
    if (!pca()->isCic()) return failed(iCtx, pmd, E_NCIC, __LINE__ , &GifControl::hWSRQ, S_WSRQ);

    const GpibWait *pmg=pGpibWait(pmd->puc());
    setState(S_WSRQ);
    clrErr();
    _pmd=pmd;
    _fTimerDone=0;
    _tiNext=tiNext(pmg->ti());
    return hWSRQ(iCtx);
  }

  /*
   * send command core
   */
  int GifControl::hCMD(int iCtx) {
    assert(_pmd);
    Umi::UmiGetBuf *pug=_pmd->pug();

    /* continuation variant */
    if (!isErr()) while (pug->sgetc() != EOF && pca()->i_spin(IGC_I2, IGC_I2_CO, IGC_I2_CO, cSpinCmd())) {
      /* wait for CO condition */
      pca()->outdat(pug->sbumpc_checked());
      _cTrans++;
      incStac(STAC_CMD_OUT);
    }

    /* completion covariant */
    if ((isErr() || (pug->sgetc() == EOF && pca()->i_spin(IGC_I2, IGC_I2_CO, 0, cSpinCmd())))) {
      const GpibCmd *pmgCmd=pGpibCmd(_pmd->puc());
      return completeSend(iCtx, pmgCmd);
    }
    return MSG_WAIT;
  }

  int GifControl::failed(int iCtx, Umi::Pmd pmd, int eErr, int iErr, int (GifControl::*pf) (int), int eState) {
    assert(!_pmd);
    _pmd=pmd;		/* lock until done */
    setState(eState);
    setErr(eErr, iErr);
    return (this->*pf)(iCtx);
  }

  int GifControl::drop(int iCtx, Umi::Pmd pmd) {
    /* drop unexpected message */
    pcn(0)->releaseDown(iCtx, pmd);
    return MSG_DONE;
  }

  int GifControl::msgCmd(int iCtx, Umi::Pmd pmd) {
    assert(!_pmd);
    if (!isState(S_IDLE, S_CMD)) return drop(iCtx, pmd);
    if (!pca()->isCic()) return failed(iCtx, pmd, E_NCIC, __LINE__ , &GifControl::hCMD, S_CMD);


    const GpibCmd *pmgCmd=pGpibCmd(pmd->puc());
    clrErr();
    /* silently ignore message with a failed transaction id */
    if (isTransFailed(pmgCmd->iTrans())) return drop(iCtx, pmd);
    else setTransCur(pmgCmd->iTrans());

    if (pca()->r_test(IGC_ADSTS, IGC_ADSTS_NATN )) {
      /* make controller active */
      pca()->outcmd(IGC_AUXCMD_TCA);
    }
    if (wasState(S_CMD, S_IDLE)) _cTrans=0;	/* new transaction */
    _pmd=pmd;
    _tiNext=tiNext(_tiTmo=pmgCmd->tiTmo());
    return hCMD(iCtx);
  }

  int GifControl::completeSend(int iCtx, const GpibTrf *pgm) {
    /* buffer done */
    Umi::Pmu pmu(0);
    const int fNeedUp((isErr() || pgm->fLast()));
    if (fNeedUp && (pmu=pcn(0)->allocUp(0, _pmd))) {
      /* failed or last => response */
      GpibWrResp*pmgCwr=new(pmu->puc()) GpibWrResp();
      pmgCwr->cTrans(_cTrans);
      pmgCwr->eErr(_eErr);
      pmgCwr->iErr(_iErr);
      setState(S_IDLE);
      failTransaction(); 
      pcn(0)->putUp(iCtx, pmu);
    }
    if (pmu || !fNeedUp) {
      /* message done */
      Umi::Pmd pmd(_pmd); _pmd=0;
      pcn(0)->releaseDown(iCtx, pmd);		/* clear channel for next */
      return MSG_DONE;
    }
    return MSG_WAIT;
  }

  /*
   * send data core
   */
  int GifControl::hCWR(int iCtx) {
    assert(_pmd);
    Umi::UmiGetBuf *pug=_pmd->pug();
    const GpibCwr *pmgCwr=pGpibCwr(_pmd->puc());

   #ifndef _MM_NO_IOSTREAM
    //std::cout << std::hex << pca()->i_was(IGC_I1, 0xff) <<  std::endl;
   #endif

    /* continuation variant */
    if (!isErr()  && (pug->sgetc() != EOF)) {
      /* wait for CO condition */
      int c=pca()->sendData(pug, pmgCwr->termOut(), cSpinDwr());
      incStac(STAC_BYTE_OUT, c);
      _cTrans+=c;
    }
   #ifndef _MM_NO_IOSTREAM
    //std::cout << pug->cDone() << '/' << pug->sgetc() << std::endl;
   #endif

    /* completion covariant */
    if ((isErr() || (pug->sgetc() == EOF && pca()->i_spin(IGC_I1, IGC_I1_DO, 0, cSpinCmd())))) {
      return completeSend(iCtx, pmgCwr);
    }
    else return MSG_WAIT;
  }

  int GifControl::msgWr(int iCtx, Umi::Pmd pmd) {
    assert(!_pmd);
    if (!isState(S_IDLE, S_CWR)) return drop(iCtx, pmd);
    const GpibCwr *pmgCwr=pGpibCwr(pmd->puc());
    clrErr();

    /* silently ignore message with a failed transaction id */
    if (isTransFailed(pmgCwr->iTrans())) return drop(iCtx, pmd);
    else setTransCur(pmgCwr->iTrans());

    if (pca()->isCic() && gts()) return failed(iCtx, pmd, E_HWFAIL, __LINE__ , &GifControl::hCWR, S_CWR);
    setMode(pmgCwr->termOut());

    if (wasState(S_CWR, S_IDLE)) _cTrans=0;	/* new transaction */
    _pmd=pmd;
    return hCWR(iCtx);
  }


  void GifControl::setMode(const GpibTermOut &termOut) {

    /* 
     * talk options
     *  EOI on EOS 
     *  High Speed 
     */
    pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_TEOS, termOut.fEoiEos() ? IGC_AUXA_TEOS : 0);		
    pca()->outaux(IGC_AUXOFF_AUXB, IGC_AUXB_HISP, termOut.fHighSpeed() ? IGC_AUXB_HISP : 0);		

    /* general */
    pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_EOSB, (termOut.fEos7()) ? 0 : IGC_AUXA_EOSB); 
    pca()->outeos(termOut.chEos());
  }

  void GifControl::setMode( const GpibTermIn &termIn ) {

    switch(termIn.cEos()) {
     case 0:
      pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_CM|IGC_AUXA_LEOS|IGC_AUXA_EOSB, termIn.fDelEnd() ? IGC_AUXA_HEM:IGC_AUXA_NHS);
      break;
     case 1:
      pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_CM|IGC_AUXA_LEOS|IGC_AUXA_EOSB, IGC_AUXA_HEM|IGC_AUXA_LEOS);
      break;
     default:
      pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_CM|IGC_AUXA_LEOS|IGC_AUXA_EOSB, IGC_AUXA_HAM|IGC_AUXA_LEOS);
      break;
    }

    /* general */
    pca()->outaux(IGC_AUXOFF_AUXA, IGC_AUXA_EOSB, (termIn.fEos7()) ? 0 : IGC_AUXA_EOSB); 
    pca()->outeos(termIn.chEos(0));
  }

  int GifControl::gts() {

    if (!pca()->r_test(IGC_ADSTS, IGC_ADSTS_NATN)) {
      /* make controller standby */
      pca()->outcmd(IGC_AUXCMD_GTS);
      if (pca()->r_test(IGC_ADSTS, IGC_ADSTS_NATN )) return 0;
      else return 1;

    }
    else return 0;
  }

  
  /*
   * read message generator
   * returns true iff last message has been sent
   * releases _pmd if set
   * sets state to S_IDLE when done
   */
  int GifControl::hCRD(int iCtx) {	/* true if done */

    assert(isState(S_CRD));

    /*
     * we always need an upstream message for the result 
     */
    GpibRdResp *pmgCrr;
    if (!_pmuNext) {
      assert(_cRdRem);
      const int cMax(_cRdRem <= SZ_DATA_MAX ? _cRdRem: SZ_DATA_MAX);
      #ifndef _MM_NO_IOSTREAM
	std::cerr << "next: " << cMax << std::endl;
      #endif
      if ((_pmuNext=pcn(0)->allocUp(cMax))==0) return MSG_WAIT ;
      pmgCrr=new(_pmuNext->puc()) GpibRdResp();
      _cRdRem -= cMax;

    }
    else {
      pmgCrr=pGpibRdResp(_pmuNext->puc());	
    }

    /* 
     * upstream message available
     */
    if (!isErr()) {

      /*
       * not failed
       * build up response data
       */
      register Umi::UmiPutBuf *pup=_pmuNext->pup();

      int c=pca()->recvData(pup, _gti, cSpinDrd());  /* holds off if Buffer full */
      _cTrans+=c;
      incStac(STAC_BYTE_IN, c);

      /* end or limit -> done */
      if ((pca()->i_was(IGC_I1, IGC_I1_END)) || !pup->canput()) {
	#ifndef _MM_NO_IOSTREAM
	  std::cerr << "done: " << std::dec << _cRdRem << ' ' << pup->canput() << std::endl;
        #endif

	if (pca()->i_was(IGC_I1, IGC_I1_END)) {
	  /* delimited */
	  pca()->i_clr(IGC_I1, IGC_I1_END);
	  pmgCrr->fDel(true);
	  pmgCrr->fDelEnd(pca()->r_test(IGC_AD1,IGC_AD1_EOI)!=0);
	  _cRdRem=0;
	}
	else {
	  /* end of buffer, handshake locked => reenable */
	  if (_cRdRem) pca()->outcmd(IGC_AUXCMD_FH);
	}
      }
      else return MSG_WAIT;	/* not yet done */
    }
    else {
      pmgCrr->eErr(_eErr);
      pmgCrr->iErr(_iErr);
    }

    /* upstream message ready */
    pcn(0)->putUp(iCtx, _pmuNext ); _pmuNext=0;
    #ifndef _MM_NO_IOSTREAM
      std::cerr << "putup " << std::endl;
    #endif

    if (isErr() || _cRdRem == 0) {
      /* done with the request */
      Umi::Pmd pmd(_pmd); _pmd=0;
      setState(S_IDLE);
      #ifndef _MM_NO_IOSTREAM
	std::cerr << "release " << std::endl;
      #endif
      pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
      return MSG_DONE;	
    }
    return MSG_WAIT;	/* not yet done */
  }

  int GifControl::msgRd(int iCtx, Umi::Pmd pmd) {
    assert(!_pmd);
    _pmd=pmd;		/* lock channel, no more messages */

    if (!isState(S_IDLE)) {
      setErr( E_STATE, __LINE__);
      return hCRD(iCtx);
    }

    if (pca()->isCic() && gts())  {
      setErr( E_HWFAIL, __LINE__);
      return hCRD(iCtx);
    }

    //std::cerr << "msgRd" << std::endl;
    const GpibCrd *pmgCrd=pGpibCrd(pmd->puc());
    clrErr();
    setState(S_CRD);

    /*
     * save transfer paramters
     */
    assert(!_pmuNext);
    _cRdRem=pmgCrd->cMax();
    _gti=pmgCrd->termIn();
    _tiNext=tiNext(_tiTmo=pmgCrd->tiTmo());
    _cTrans=_cTransPrev=0;

    /* release Holdoff from previous transfer REMIND: before setMode() ?  */
    pca()->outcmd(IGC_AUXCMD_FH);	/* RESETs DI 	*/
    setMode(_gti);

    /* setup task to save params, do not append yet */
    return hCRD(iCtx);
  }

  /*
   * status reporting 
   */
  int GifControl::msgSta(int iCtx, Umi::Pmd pmd) {
    if (isState(S_POFF)) return putUpResp(iCtx, pmd, E_STATE, __LINE__ );
    const GpibSta *pmg=pGpibSta(pmd->puc());

    pca()->outspoll(pmg->fMss() ? pmg->iStb() | 0x40 : pmg->iStb() & ~0x40);

    return putUpResp(iCtx, pmd, E_OK);
  }

  /* message put */ 
  Umi::UmiDriver::DownE GifControl::putDown(int iCtx, Umi::Pmd pmd, int iChan) {


    switch (pmd->puc()->eType()) {
      case MSG_GpibInit:
        return msgInit(iCtx, pmd);
      case MSG_GpibFini:
        return msgFini(iCtx, pmd);
      case MSG_GpibIfc:
        return msgIfc(iCtx, pmd);
      case MSG_GpibRen:
        return msgRen(iCtx, pmd);
      case MSG_GpibCmd:
        return msgCmd(iCtx, pmd);
      case MSG_GpibCwr:
        return msgWr(iCtx, pmd);
      case MSG_GpibCrd:
        return msgRd(iCtx, pmd);
      case MSG_GpibSta:
        return msgSta(iCtx, pmd);
      case MSG_GpibWait:
        return msgWait(iCtx, pmd);
      default:
        assert(0);
    }
    return 0;
  }

  int GifControl::open(int iChan) {
    assert(iChan == 0);
    return 0;
  }

  void GifControl::close(int iChan) {
    assert(iChan == 0);
    if (!isState(S_POFF)) {
      pca()->reset(false);
      pca()->clrDriver(this);
    }
    _pmuNext=0; 	/* deallocated */
    _pmd=0;
    setState(S_POFF);
  }


  int GifControl::switchState(int iCtx) {
    switch (eState()) {
     case S_CRD:
      return hCRD(iCtx);
     case S_CWR:
      return hCWR(iCtx);
     case S_CMD:
      return hCMD(iCtx);
     case S_WSRQ:
      return hWSRQ(iCtx);
     case S_IFC:
      return hIFC(iCtx);
     case S_REN:
      return hREN(iCtx);
    }
    return 0;
  }

  /* 
   * interupt handler - all interupt register already read
   */
  int GifControl::interrupt(int iCtx) { return switchState(iCtx); }
  void GifControl::backenable(int iCtx, int iChan) { switchState(iCtx); }

  /* timer handler */
  int GifControl::timer(int iCtx, const Umi::Time &ti) {

    switch (eState()) {
     case S_CRD:
     case S_CWR:
     case S_CMD:
      {
	/* transfer in progress */
	if (_cTrans !=  _cTransPrev) {
	  _cTransPrev=_cTrans;
	  _tiNext=tiNext(_tiTmo);
	}
	else if ( ti >= _tiNext ) {
	  setErr(E_TMO, __LINE__);
	  return switchState(iCtx);
	}
      }
      break;
     case S_IFC:
     case S_REN:
     case S_WSRQ:
      if ((_fTimerDone = ( ti >= _tiNext ))) {
	return switchState(iCtx);
      }
      break;
    }
    return 0;
  }

  char * GifControl::print( char *pchBase, int s) {
    char *pch=pchBase;
    int i;
    for (i=0; i< CNT_STAC; i++) {
      pch+=sprintf(pch, "%d ", _mpcStac[i]);
    }
    return pca()->print(pch, s-(pch-pchBase));
  }

  GifControl::GifControl( GifCard *pca):UmiDriver("gco", pca), _pmd(0), _eErr(0), _iErr(0), 
   _fTimerDone(0), _cTrans(0), _cTransPrev(0), _pmuNext(0), _cRdRem(0), _iTransCur(0), _iTransFailed(0) {
    for ( int i=0; i<CNT_STAC; i++) _mpcStac[i]=0;
  }

  GifControl::~GifControl() { 
  }

}



namespace INdepGpib100 {

#ifndef _MM_NO_IOSTREAM
  std::ostream &operator<< ( std::ostream &os, const GifDevice &gd) {
    return os << gd.eState() << " " << *gd.pca() ;
  }
#endif

  int GifDevice::putUpDone( int iCtx, const Umi::UmiMsgDown *pmd , ErrE eErr, int iErr  ) {

    /*
     * release request, allocate responce
     */
    Umi::Pmu pmu=pcn(0)->allocUpForced(0);	/* empty data part 	*/
    assert(pmu);

    GpibResp*pmgCrr=new(pmu->puc()) GpibResp();

    pmgCrr->eErr(eErr);
    pmgCrr->iErr(iErr);
    pcn(0)->putUp(iCtx, pmu);
    pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    return MSG_DONE;
  }

  Umi::UmiDriver::DownE GifDevice::msgInit(int iCtx, Umi::Pmd pmd ) {
    const GpibInit *pmgInit=pGpibInit(pmd->puc());
    if (!isState(S_POFF)) return putUpDone(iCtx, pmd, E_STATE, __LINE__ );


    {
      const GpibIfConf &gic(pmgInit->ifConfig());

      if (
	  ( /* gic.iPa() < 0 || */ gic.iPa() > 30) || (
	    gic.fSa() && ( /* gic.iSa() < 0 || */ gic.iSa() >31 ) 
	  )
      ) return putUpDone(iCtx, pmd, E_ADR, __LINE__) ;
      else _gic=gic;
    }

    /*
     * direct interrupts to this driver
     */
    if (pca()->setDriver(this)) return putUpDone(iCtx, pmd, E_INUSE, __LINE__) ;

    if (pca()->reset(_gic.fSc())) {
      pca()->clrDriver(this);
      return putUpDone(iCtx, pmd, E_HWFAIL, __LINE__);
    }

    /* REMIND: questionable for non-SC ? */
    //if (isQuick() && isSc() && pca()->read(QGC_MONO)) return putUpDone( iCtx, umd, E_HWFAIL, __LINE__ );

    pca()->outreg( IGC_ADMOD, IGC_ADMOD_TRM0|IGC_ADMOD_TRM1| (gic().fSa() ? IGC_ADMOD_ADM1:IGC_ADMOD_ADM0));
    pca()->outreg( IGC_AD01, gic().iPa() );
    pca()->outreg( IGC_AD01, gic().fSa() ? ( 0x80 | gic().iSa() ) : 0xe0 );

    /*
     * initialize auxiliary mode registers
     */
    pca()->outaux( IGC_AUXOFF_CLK,  0xff, pca()->cNecClk() );	/* counter 	*/
    pca()->outaux( IGC_AUXOFF_WPP,  0xff, 0x10);		/* lpe false	*/
    pca()->outaux( IGC_AUXOFF_AUXA, 0xff, 0);			/* nhs mode	*/
    pca()->outaux( IGC_AUXOFF_AUXB, 0xff, 0 ); 			/* active high	*/
    pca()->outaux( IGC_AUXOFF_AUXE, 0xff, IGC_AUXE_CLR|IGC_AUXE_TRG);	/* holdoff	*/

    if (pca()->isiGpib()) {
      //pca()->outaux( IGC_AUXOFF_AUXF, 0xff, IGC_AUXF_RFDH );		
    }

    pca()->outcmd( IGC_AUXCMD_IPO );	/* leave reset */


    pca()->outreg( IGC_I1, IGC_I1_DI|IGC_I1_DO|IGC_I1_DEC|IGC_I1_DET );
    pca()->outreg( IGC_I2, IGC_I2_ADSC );
    setState(S_IDLE);
    _eMsg=0; _eEvent='-';
    return putUpDone(iCtx, pmd, E_OK);
  }

  int GifDevice::msgFini(int iCtx, Umi::Pmd pmd) {
    if (isState(S_POFF)) return putUpDone(iCtx, pmd, E_STATE, __LINE__ );
    assert(isGpibFini(pmd->puc()));
    int err;

    pca()->reset(false);
    err=pca()->clrDriver(this);
    assert(!err);

    setState(S_POFF);
    return putUpDone(iCtx, pmd, E_OK);	/* force message, user is draining  */
  }


  int GifDevice::putDown(int iCtx, Umi::Pmd pmd, int iChan) { 

    switch (pmd->puc()->eType()) {
      case MSG_GpibInit:
        return msgInit(iCtx, pmd);
      case MSG_GpibFini:
        return msgFini(iCtx, pmd);
      default:
        doSm(iCtx, pmd->puc()->eType(), pmd, 'p');
    }
    return 0;
  }

  char * GifDevice::print( char *pchBase, int s) {
    char *pch=pchBase;
    int i;
    pch+=sprintf(pch, "s(%d,%d,%c,%x) ", eState(), eStLast(), eEvent(), eMsg());
    for (i=0; i< CNT_STAC; i++) {
      pch+=sprintf(pch, "%d ", _mpcStac[i]);
    }
    return pca()->print(pch, s-(pch-pchBase));
  }

  int GifDevice::open(int iChan) {
    assert(iChan == 0);
    return 0;
  }

  void GifDevice::close(int iChan) {
    assert(iChan == 0);
    if (!isState(S_POFF)) {
      pca()->reset(false);
      pca()->clrDriver(this);
    }
    setState(S_POFF);
  }

  bool GifDevice::putUpEvent(int iCtx, int eEvent) {
    /*
     * flush any previous upstream message
     */
    if (_pmuNext) (pcn(0)->putUp(iCtx, _pmuNext ), _pmuNext=0);
    if ((_pmuNext=pcn(0)->allocUp(0))==0) return false;	

    GpibDeviceEvent *pmgDe(new(_pmuNext->puc()) GpibDeviceEvent());
    pmgDe->eEvent(eEvent);	/* 488.2 INITIALIZE	*/
    (pcn(0)->putUp(iCtx, _pmuNext ), _pmuNext=0);
    return true;
  }


  void GifDevice::sendDataCancel(int iCtx) {
    if (_pmdCur) {
      Umi::Pmd pmd(_pmdCur);
      _pmdCur=0;
      pcn(0)->releaseDown(iCtx, pmd);		
    }
  }

  bool GifDevice::sendData(int iCtx, Umi::Pmd pmd) {
    if (pmd) {
      assert(_pmdCur == 0);
      _pmdCur=pmd;
    }
    else pmd=_pmdCur;

    const GpibDeviceOutput *pmg=pGpibDeviceOutput(pmd->puc());
    Umi::UmiGetBuf *pug=pmd->pug();


    /* int c= */ pca()->sendData(pug, GpibTermOut().fEnd(pmg->fEND()), cSpinWr());
    if (pug->sgetc() == EOF) {
      bool fDone(pGpibDeviceOutput(pmd->puc())->fEND());
      _pmdCur=0;
      pcn(0)->releaseDown(iCtx, pmd);		
      return fDone;
    }
    return false;
  }

  bool GifDevice::recvData(int iCtx) {	/* true on EOM */
    /*
     * we always need an upstream message
     */
    GpibDeviceInput *pmgDi;
    if (!_pmuNext) {
      const int cMax(256);
      if ((_pmuNext=pcn(0)->allocUp(cMax))==0) return false ;
      pmgDi=new(_pmuNext->puc()) GpibDeviceInput();
    }
    else {
      pmgDi=pGpibDeviceInput(_pmuNext->puc());	
    }
    register Umi::UmiPutBuf *pup=_pmuNext->pup();
    const GpibTermIn gti;

    int c=pca()->recvData(pup, gti, cSpinRd());  /* REMIND: holds off if Buffer full! */
    incStac(STAC_BYTE_IN, c);
    //std::cerr << "read " << c << std::endl;

    /* 
     * FIXME read I1 again to recognize delayed END on 
     * NEC7210
     * FIXME: i_test resets DI interrupt 
     */
    bool fEom((pca()->i_clr(IGC_I1, IGC_I1_END))!=0);
    if ( fEom || !pup->canput() ) {
      /* message done */
      //std::cerr << "putup " << fEom << std::endl;
      pmgDi->fEND(fEom);
      pcn(0)->putUp(iCtx, _pmuNext );
      _pmuNext=0;
    }
    return fEom;
  }


  /*
   * default downstream message handler
   */
  Umi::Pmd GifDevice::defaultDown(Umi::Pmd pmd ) {
    if ( pmd && (pmd->puc()->eType() == MSG_GpibDeviceStatusReport )) {
      const GpibDeviceStatusReport *pmg(pGpibDeviceStatusReport(pmd->puc()));
      pca()->outspoll((pmg->fStb() & pmg->fSre()) ? pmg->fStb() | 0x40 : pmg->fStb() & ~0x40);
       #if 0
       #ifndef _MM_NO_IOSTREAM
	std::cerr << "setStb() " << std::hex 
	  << gds().fStb() << ' ' 
	  << gds().fSre() << ' ' 
	  << gds().fForce() << ' ' 
	  << std::endl;
       #endif
       #endif
    }
    return pmd;
  }

  /*
   * state handlers
   */
  void GifDevice::hDCAS(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert (isState(S_DCAS));
    if (pmd) {
      if (eMsg == MSG_GpibDeviceInitAck) {
	pca()->outcmd( IGC_AUXCMD_AV );
	setState(S_IDLE);
      }
      pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    }
  }

  void GifDevice::hIDLE(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert (isState(S_IDLE));
    if (defaultDown(pmd))  pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    else if (isBrq()) {
      if (putUpEvent(iCtx, 'u')) pca()->i_clr(IGC_I1, IGC_I1_DO);
    }
    else if (isBavGet()) {
      setState(S_READ);
      hREAD(iCtx, 0, 0);
    }
  }

  void GifDevice::hREAD(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert (isState(S_READ));
    if (defaultDown(pmd))  pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    else if (isBrq()) {
      if (putUpEvent(iCtx, 'u')) {
        pca()->i_clr(IGC_I1, IGC_I1_DO);
        setState(S_IDLE);
      }
    }
    else if (isBavGet()) {
      if (pca()->i_was(IGC_I1, IGC_I1_DET)) {
	if (putUpEvent(iCtx, 't')) {
	  pca()->outcmd( IGC_AUXCMD_AV );
	  pca()->i_clr(IGC_I1, IGC_I1_DET);
        }
      }
      else if (recvData(iCtx)) setState(S_WAIT);
    }
  }

  void GifDevice::hBAV(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert (isState(S_BAV));

    if (pmd && (eMsg == MSG_GpibDeviceOutput)) {
      int fQuery(pmd->pug()->sgetc() != EOF);	/* response data available */

      if (!fQuery || putUpEvent(iCtx, 'i')) {
	setState(S_READ);
	hREAD(iCtx, 0, 0);
      }
      pcn(0)->releaseDown(iCtx, pmd);		
    }
    else if (defaultDown(pmd)) pcn(0)->releaseDown(iCtx, pmd);		
    else {
      /* retry */
      if (putUpEvent(iCtx, 'i')) {
	setState(S_READ);
	hREAD(iCtx, 0, 0);
      }
    }
  }

  void GifDevice::hBRQ(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert(isState(S_BRQ));
    if (pmd && (eMsg == MSG_GpibDeviceOutput)) {
      int fQuery(pmd->pug()->sgetc() != EOF);	/* response data available */
      if (fQuery) {
        setState(S_RESP);
	hRESP(iCtx, eMsg, pmd);
      }
      else {
        if (putUpEvent(iCtx, 'u')) setState(S_IDLE);
	pcn(0)->releaseDown(iCtx, pmd);		
      }
    }
    else if (defaultDown(pmd)) pcn(0)->releaseDown(iCtx, pmd);		
  }

  void GifDevice::hWAIT(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert(isState(S_WAIT));
    if (pmd && (eMsg == MSG_GpibDeviceOutput)) {
      int fQuery(pmd->pug()->sgetc() != EOF);	/* response data available */

      if (fQuery) {
	/* start sending data */
	setState(S_RESP);
	hRESP(iCtx, eMsg, pmd);
      }
      else {
        setState(S_IDLE);
	pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
      }
    }
    else if (defaultDown(pmd)) pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    else if (isBavGet()) setState(S_BAV);
    else if (isBrq()) setState(S_BRQ);
  }

  void GifDevice::hPOFF(int iCtx, int eMsg, Umi::Pmd pmd ) {
    if (pmd) pcn(0)->releaseDown(iCtx, pmd);		
  }

  void GifDevice::hRESP(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert(isState(S_RESP));
    if (defaultDown(pmd) && (eMsg != MSG_GpibDeviceOutput)) pcn(0)->releaseDown(iCtx, pmd);		
    if (sendData(iCtx, pmd)) setState(S_DONE);
  }

  void GifDevice::hDONE(int iCtx, int eMsg, Umi::Pmd pmd ) {
    assert(isState(S_DONE));
    if (defaultDown(pmd)) pcn(0)->releaseDown(iCtx, pmd);		
    else if (isBavGet()) {
      setState(S_READ);
      pca()->i_clr(IGC_I1, IGC_I1_DO);
      hREAD(iCtx, 0, 0);
    }
  }

  void GifDevice::doSm(int iCtx, int eMsg, Umi::Pmd pmd, int eEvent ) {
    _eEvent=eEvent;
    if (eMsg != 0 && eMsg != MSG_GpibDeviceStatusReport) _eMsg=eMsg;
   #ifdef DEBUG
    if (pmd || pca()->getIsChange()) {
      //std::cerr << "sm( " << *this << " <" << pmd << ">" << std::endl;
    }
   #endif

    /*
     * special handling for DCAS
     */
    if (!pmd && pca()->i_was(IGC_I1, IGC_I1_DEC)) {
      /* any state  */
      if (putUpEvent(iCtx, 'I')) {
	pca()->i_clr(IGC_I1, IGC_I1_DEC);
	sendDataCancel(iCtx);
        setState(S_DCAS);
      }
      else return;
    }

//    (this->*mphs[eState()])(iCtx, eMsg, pmd);
      switch(eState()) {
	case S_POFF: hPOFF(iCtx, eMsg, pmd); break;
	case S_BAV: hBAV(iCtx, eMsg, pmd); break;
	case S_BRQ: hBRQ(iCtx, eMsg, pmd); break;
	case S_DCAS: hDCAS(iCtx, eMsg, pmd); break;
	case S_DONE: hDONE(iCtx, eMsg, pmd); break;
	case S_IDLE: hIDLE(iCtx, eMsg, pmd); break;
	case S_READ: hREAD(iCtx, eMsg, pmd); break;
	case S_RESP: hRESP(iCtx, eMsg, pmd); break;
	case S_WAIT: hWAIT(iCtx, eMsg, pmd); break;
      }

    /* status change check */
    if (pca()->i_was(IGC_I2, IGC_I2_ADSC)) {
      const Umi::UmiMsgUp *pmuStat;			

      if (!(pmuStat=pcn(0)->allocUp(0))) return ;

      GpibDeviceStatus* pmgSt=new(pmuStat->puc()) GpibDeviceStatus();
      pmgSt->fStat(pca()->getStatE());
      pcn(0)->putUp(iCtx, pmuStat );
      pca()->i_clr(IGC_I2, IGC_I2_ADSC);
    }

   #ifdef DEBUG
    if (pca()->getIsChange()) {
      //std::cerr << "sm) " << *this << std::endl;
    }
   #endif
  }

  /*
  GifDevice::PFhState GifDevice::mphs[GifDevice::CNT_STATES] = {
    &GifDevice::hPOFF,
    &GifDevice::hBAV,
    &GifDevice::hBRQ,
    &GifDevice::hDCAS,
    &GifDevice::hDONE,
    &GifDevice::hIDLE,
    &GifDevice::hREAD,
    &GifDevice::hRESP,
    &GifDevice::hWAIT,
  };
  */

    

  /*
   * backenable() - upstream message available again.
   * Called iff a preceding call to allocUp() failed.
   */
  void GifDevice::backenable(int iCtx, int iChan) {
    doSm(iCtx, 0, 0, 'b');
  }

  /* interupt handler */
  int GifDevice::interrupt(int iCtx) {
    doSm(iCtx, 0, 0, 'i');
    return 0;
  }

  /* timer handler */
  int GifDevice::timer(int iCtx, const Umi::Time &ti) {
    /* not used */
    return 0;
  }

  GifDevice::GifDevice( GifCard *pca):Umi::UmiDriver("gdi", pca), _pmuNext(0), _pmdCur(0), _eEvent('-'), _eMsg(0), _eStLast(-1) { 
    for ( int i=0; i<CNT_STAC; i++) _mpcStac[i]=0;
  }
  GifDevice::~GifDevice( ) { }

}




namespace INdepGpib100 {


  GifTest::GifTest( GifCard *pca):UmiDriver("gti", pca), _cIntr(0) {
  }

  GifTest::~GifTest() { 
  }



  /*
   * nop handler
   */
  Umi::UmiDriver::DownE GifTest::msgNop(int iCtx, Umi::Pmd pmd ) {
    Umi::Pmu pmu(pcn(0)->allocUp(0, pmd));
    assert(isState(S_INIT));

    GpibInfoResp *pgm=new(pmu->puc()) GpibInfoResp();
    pgm->info( GpibInfo(pca()->eArch(), _cIntr) );

    pcn(0)->putUp( iCtx, pmu );
    pcn(0)->releaseDown(iCtx, pmd);
    return MSG_DONE;
  }


  /*
   * status reporting 
   */
  int GifTest::msgPeek(int iCtx, Umi::Pmd pmd) {
    const GpibPeek *pmg=pGpibPeek(pmd->puc());
    assert(isState(S_INIT));

    int i=(pca()->isIntReg(pmg->iPort()) ? pca()->i_get(pmg->iPort(), 0xff) : pca()->r_read(pmg->iPort()));
    return putBackDone(iCtx, pmd, E_OK, i);		/* REMIND -- ugly */
  }

  int GifTest::msgPoke(int iCtx, Umi::Pmd pmd) {
    const GpibPoke *pmg=pGpibPoke(pmd->puc());
    assert(isState(S_INIT));

    pca()->outreg(pmg->iPort(), pmg->iVal());
    if (pmg->iPort() == IGC_AUXMOD && pmg->iVal() == IGC_AUXCMD_RES) {
      /* reset -> clear shadows registers */
      pca()->is_clear();
    }
    return putBackDone(iCtx, pmd, E_OK);			/* done */
  }


  /* message put */ 
  Umi::UmiDriver::DownE GifTest::putDown(int iCtx, Umi::Pmd pmd, int iChan) {
    switch (pmd->puc()->eType()) {
      case MSG_GpibNop:
        return msgNop(iCtx, pmd);
      case MSG_GpibPeek:
        return msgPeek(iCtx, pmd);
      case MSG_GpibPoke:
        return msgPoke(iCtx, pmd);
      default:
        assert(0);
    }
    return 0;
  }

  int GifTest::open(int iChan) {
    assert(iChan == 0);
    if (pca()->setDriver(this)) return E_INUSE;
    setState(S_INIT);
    return 0;
  }

  void GifTest::close(int iChan) {
    assert(iChan == 0);
    if (isState(S_INIT)) {
      pca()->reset(false);
      pca()->clrDriver(this);
    }
    setState(S_IDLE);
  }


  /* 
   * interupt handler - all interupt register already read
   */
  int GifTest::interrupt(int iCtx) {
    _cIntr++;
    return 0;
  }

  /* timer handler */
  int GifTest::timer(int iCtx, const Umi::Time &ti) {
    return 0;
  }

  char * GifTest::print( char *pchBase, int s) {
    return pca()->print(pchBase, s);
  }

  /*
   * default response message generator
   */
  int GifTest::putBackDone( int iCtx, const Umi::UmiMsgDown *pmd , ErrE eErr, int iErr  ) {


    /*
     * release request, allocate responce
     */
    Umi::Pmu pmu=pcn(0)->allocUp(0, pmd);	/* empty data part 	*/
    assert(pmu);			/* REMIND */
    GpibResp*pmgCrr=new(pmu->puc()) GpibResp();
    pmgCrr->eErr(eErr);
    pmgCrr->iErr(iErr);
    pcn(0)->putUp(iCtx, pmu);
    pcn(0)->releaseDown(iCtx, pmd);		/* clear channel	*/
    return MSG_DONE;
  }

}



extern "C" {
}



#define CNT_CARD 1
#define CNT_DRIV 3
#define CNT_MSGS 4
#define CNT_DRCH 1	/* per driver */

extern "C" {


  namespace Gumi=INdepGpib100;
  namespace Umi=INdepUmi100;

  int getMemGifCard(struct UmiMod*pum, struct UmiMemInfo* mpmi, int cmi) {
    UmiMemInfo *pmi=mpmi;
    const int cNeed(1 + CNT_CARD +
              CNT_DRIV+
              CNT_DRIV*CNT_DRCH+
              CNT_DRIV*CNT_DRCH*CNT_MSGS*2);
    if (cmi < cNeed) return -cNeed;

    pmi->_s=sizeof(Umi::UmiEnvRed);
    pmi->_p=0;
    pmi++;

    pmi->_s=sizeof(Gumi::GifCard);
    pmi->_p=0;
    pmi++;

    pmi->_s=sizeof(Gumi::GifControl);
    pmi->_p=0;
    pmi++;

    pmi->_s=sizeof(Gumi::GifDevice);
    pmi->_p=0;
    pmi++;

    pmi->_s=sizeof(Gumi::GifTest);
    pmi->_p=0;
    pmi++;

    for (int i=0; i< CNT_DRIV*CNT_DRCH; i++) {
      pmi->_s=sizeof(Umi::UmiChannel);
      pmi->_p=0;
      pmi++;


      for (int i=0; i<CNT_MSGS; i++) {
	pmi->_s=sizeof(Umi::UmiMsgDownBuf);
	pmi->_p=0;
	pmi++;
      }

      for (int i=0; i<CNT_MSGS; i++) {
	pmi->_s=sizeof(Umi::UmiMsgUpBuf);
	pmi->_p=0;
	pmi++;
      }
    }


    return pmi-mpmi;
  }

  void *newGifCard(struct UmiMod*pum, const struct UmiEnvC*pueC,  struct UmiMemInfo* mpmi, int cmi, const struct CardType *pct, long lAddr) {
    UmiMemInfo *pmi=mpmi+0;
    assert(pmi->_s == sizeof(Umi::UmiEnvRed));
    Umi::UmiEnvRed *pue= new(pmi->_p) Umi::UmiEnvRed(pueC);
    pmi++;

    assert(pmi->_p && pmi->_s == sizeof(Gumi::GifCard));
    Gumi::GifCard *pca= new(pmi->_p) Gumi::GifCard(lAddr, pct->_eArch, true);
    pmi++;

    Umi::UmiDriver* mppud[CNT_DRIV];

    assert(pmi->_s == sizeof(Gumi::GifControl));
    pca->initDriver(mppud[0]=new(pmi->_p) Gumi::GifControl(pca));
    pmi++;

    assert(pmi->_s == sizeof(Gumi::GifDevice));
    pca->initDriver(mppud[1]=new(pmi->_p) Gumi::GifDevice(pca));
    pmi++;

    assert(pmi->_s == sizeof(Gumi::GifTest));
    pca->initDriver(mppud[2]=new(pmi->_p) Gumi::GifTest(pca));
    pmi++;

    for (int i=0; i< CNT_DRIV*CNT_DRCH; i++) {
      assert(pmi->_s == sizeof(Umi::UmiChannel));
      Umi::UmiChannel *puc;
      mppud[i]->init(puc=new(pmi->_p) Umi::UmiChannel(mppud[i], 0, pue));
      pmi++;

      for (int j=0; j<CNT_MSGS; j++) {
	assert(pmi->_s == sizeof(Umi::UmiMsgDownBuf));
	puc->initPool(new(pmi->_p) Umi::UmiMsgDownBuf);
	pmi++;
      }

      for (int j=0; j<CNT_MSGS; j++) {
	assert(pmi->_s == sizeof(Umi::UmiMsgUpBuf));
	puc->initPool(new(pmi->_p) Umi::UmiMsgUpBuf);
	pmi++;
      }
    }


    return pca;
  }

  void deleteGifCard(struct UmiCard *puc) {
  }


  struct UmiMod umGpib = { 
    3, 1, newGifCard, getMemGifCard
  };

}
